#include <iostream>
#include <vector>
using namespace std;

typedef vector<int> VI;
typedef VI::iterator IT;

void Afiseaza(VI v)
{
	for ( IT it = v.begin(); it != v.end(); ++it )
		cout << *it << " ";
	cout << '\n';
}

int main()
{
	VI v;
	v.reserve(8);  
	
	for (int i = 1; i <= 8; i++ )
		v.push_back(i);     // v = [1, 2, 3, 4, 5, 6, 7, 8]
	Afiseaza(v);            // 1 2 3 4 5 6 7 8

 	IT it1(v.begin() + 4);
	cout << *it1 << '\n';   // afiseaza 5

	// sterge intervalul [v.begin(), it)
 	IT it = v.erase(v.begin() + 1, it1); 
 	cout << *it << '\n';   // afiseaza 5 (urmatorul dupa ultimul sters)

 	// it1 s-a invalidat
  	cout << *it1 << '\n';  // comportament nedefinit
			              
	Afiseaza(v);           // 1  5 6 7 8

	system("pause");
	return 0;
}

