// Verificarea faptului ca operatia cu map : m[i] = j  are cost mai mare la inserare decat m.insert()

#include <iostream>
#include <map>
using namespace std;

template <typename T>
struct Func {
    bool operator()(const T& t) const 
    {
        return t > 5;
    }
};     
   
class A {
    int n;
public:
    A(int i = 0)  : n(i)
    {
        cout << "Ctor\n";
    }
   ~A() 
    {
        cout << "Dtor\n";
    }
      
    A& operator=(const A& ob)   // supraincarcarea operatorului de atribuire
    {
        n = ob.n;
        cout << "Atribuire\n";
        return *this;
    }    
    friend ostream& operator << (ostream& os, const A& ob)     // operator insertie
    {
        os << ob.n;
        return os;
    }    
};        
        
int main()
{
    map<int, A> m;
//    INSERARE
/*                
    m[1] = 10;            // 6 apeluri ale constructorului, 3 ATRIBUIRi
    m[2] = 20;    // cate 2 A() si 2 = pt fiecare operatie
    m[3] = 30;
*/

    typedef map<int, A> M;
    pair<M::iterator, bool> p = m.insert(make_pair(4, A()));
    p.first->second = 2222;
//    m[3] = 33;   // 1 A() si un pe operatie
   // echivlent cu
//  (*(m.insert( make_pair(1,A())).first )).second = 1234; // aici un A()  
 
    
/*
    m.insert(make_pair(1, 10));   // 3 apeluri ale constructorului
    m.insert(make_pair(2, 20));
    m.insert(make_pair(3, 30));
*/
//    m.insert(make_pair(3, 70));)+
    
/*  
    m.erase(1);
    m.insert(make_pair(1, 777));

    typedef map<int, A>::iterator IT;
    for ( IT it = m.begin(); it != m.end(); ++it )
        cout << it->first << " " << it->second << "\n";
        
 */   
    system("pause");
    
    return 0;
}    
