/*
iterator erase(iterator iter);
iterator erase(iterator first, iterator last);
void clear() const;
*/
#include <iostream>
#include <deque>

using namespace std;

typedef deque<int >  INTDEQUE;
typedef INTDEQUE::iterator IT;
void print_contents (INTDEQUE  deque);

int main()
{
    
    INTDEQUE  a;
    a.push_back(1);
    a.push_back(2);
    a.push_back(3);
    a.push_back(4);
    a.push_back(5);

 
    print_contents (a);

    //  stege al doile element
    a.erase(a.begin() + 1);
    print_contents(a);

    // sterge ultimele 2 elemente
    a.erase(a.end()-2, a.end());
    print_contents(a);

    a.clear();
    print_contents(a);

	return 0;
	
}

void print_contents (INTDEQUE  deque)
{

	IT pdeque;

    for(pdeque = deque.begin();
        pdeque != deque.end();
        pdeque++)
    {
        cout << *pdeque <<" " ;
    }
        cout<<endl;
}

/*
Iesire:

1 2 3 4 5
1 3 4 5
1 3
*/
