#include <fstream>
#include <stdio.h>
#include <vector>
#include <algorithm>
#include <iterator>
using namespace std;

int n;
vector<int> h;

// in heap cel mai mic e  primul
bool Comp(int sm, int gr)
{
	if ( sm < gr &&  h[gr] < h[sm] /*||
         !(gr < sm) && !(h[sm] < h[gr])*/ ) return true;        // CAZUL >= FOLOSIND DOAR op <    (. sau = nu exista)
	return false;
}

void add_heap(int nr)
{
	h.push_back(nr);  // pune nr pe ultima pozitie
	if ( h.size() > 1)
		push_heap(h.begin(), h.end(), Comp);  // reorganizeaza heap-ul

	return;
}

int get_from_heap()
{
	if (h.size() == 0) return -1;
	int min = h[0];
	if (h.size() >1 )
		pop_heap(h.begin(), h.end(), Comp);
	h.pop_back();
	return min;
}


ifstream fin("heap.in");
ofstream fout("heap.out");

int main ()
{
	fin >> n;
	int x;
	for ( int i = 0; i < n; i++ )
	{
		fin >> x;
		h.push_back(x);
	}

	copy(h.begin(), h.end(), ostream_iterator<int>(fout, " " ));
	fout << '\n';
	
	make_heap(h.begin(), h.end(), greater<int>());
    copy(h.begin(), h.end(), ostream_iterator<int>(fout, " " ));
    
    fout << '\n';
    while ( h.size() )
	{
	    fout << h[0] << '\n';       // implicit este: less<int>() - descrescator         
	    pop_heap(h.begin(), h.end(), greater<int>());  // crescator   
	    h.pop_back();
	}    

	fin.close();
	fout.close();
	return 0;
}
