#include <iostream>
#include <map>
#include <string>
#include <iomanip>
using namespace std;

int main()
{
//  chei sortate descrescator
//  typedef multimap<string, string, greater<string> > MM; 

	typedef multimap<string, string > MM; // cheile sortate crescator
    typedef MM::iterator IT;

    MM m;  // creaza un multimap vid

    // insereaza elemente in ordine aleatoare
    m.insert(make_pair("Luni","Chimie"));
    m.insert(make_pair("Joi","Romana"));
    m.insert(make_pair("Marti","Istorie"));
    m.insert(make_pair("Luni","Matematica"));
    m.insert(make_pair("Joi","Fizica"));
    m.insert(make_pair("Luni","Engleza"));
    m.insert(make_pair("Joi","Informatica"));
    m.insert(make_pair("Marti","Informatica"));
    m.insert(make_pair("Vineri","Geografie"));

    // afiseaza toate elementele din multimap
    for (IT it = m.begin(); it != m.end(); ++it) 
        cout << it->first << " " << it->second << '\n';
    
    cout << '\n';

    // afiseaza toate valorile pentru cheia "Luni"
    string zi("Luni");
    cout << zi << ": " << endl;
    for (IT it = m.lower_bound(zi); it != m.upper_bound(zi); ++it)
            cout << "    " << it->second << endl;
    
    // afiseaza toate cheile pentru valoarea "Informatica"
    string s = "Informatica";
    cout << '\n' << s << ": " << '\n';
    for (IT it = m.begin(); it != m.end(); ++it) 
        if ( it->second == s ) 
            cout << "    " << it->first << endl;
            
    system("pause");
}
