// Clase Template cu parametri generici care au valori (tipuri) implicite

#include <iostream>
using namespace std;

template <typename T1 = int, typename T2 = char>
class A {
    T1 a;
    T2 b;
public:
    A();
    A(T1 n = 0, T2 m = 0);
    T1 Geta() const;
    T2 Getb() const;
};


template <typename T1, typename T2>
A<T1,T2>::A() {}


template <typename T1, typename T2>
A<T1,T2>::A(T1 n, T2 m)
{
    a = n;
    b = m;
}

template <typename T1, typename T2>
T1 A<T1, T2>::Geta() const
{
    return a;
}

template <typename T1, typename T2>
T2 A<T1, T2>::Getb() const
{
    return b;
}


int main()
{
/*
    A<int, int> o1(100, 45);           // instantiaza o noua clasa A<int> [specializare] pe baza sablonului
    cout << o1.Geta() << "\n";

    A<char, double> o2('E', 6.423);
    cout << o2.Geta() << "\n";
    int sir[] = { 2, 4, 6, 7 };
    A<const char*, const int*> o3("PANTA REI", sir);
    cout << o3.Geta() << "\n";
*/
    A<> ob4(3, 'K');
    cout << ob4.Geta() << " " << ob4.Getb() << "\n";

    A<int> ob5(30, 'L');
    cout << ob5.Geta() << " " << ob5.Getb() << "\n";

    system("pause");
}




