#include <iostream>
#include <string>
using namespace std;


template <typename T>
class Coada {
    enum { DIM = 100 };
    T q[DIM];
    int prim, ultim;
public:
    Coada();
    void Adauga(T val); 
    T Scoate();
    void Afiseaza() const; 
};

template <typename T>
Coada<T>::Coada() : prim(0), ultim(0) { }

template <typename T>
void Coada<T>::Adauga(T val)
{ 
    q[ultim++] = val; 
} 

template <typename T>
T Coada<T>::Scoate() 
{ 
    return q[prim++]; 
}

template <typename T>
void Coada<T>::Afiseaza() const 
{
    for (int i = prim; i <= ultim; i++ ) 
        cout << q[i] << " "; 
    cout << "\n"; 
}

int main()
{
    Coada<string> Q1;
    Coada<Coada<int> > Q2;
}
    
