// Continerea claselor sablon (Constructori)
#include <iostream>

template <class T>
class A {
    T a;
public:
    A() : a(0) { }
    A(T b) : a(b) { }
    T Get_a() const { return a; }
};

template <class T1, class T2>
class B {
    A<T1> a;
    T2 t;
public:
    B() { };
    B(A<T1> x, T2 y) : a(x), t(y) { };
    T2 Get_t() const { return t; }
    T1 Get_a() const { return a.Get_a(); }
};

int main()
{
    B<char, int>  b('Q', 8);
    std::cout << b.Get_a() << " " << b.Get_t();
}



