#include <iostream>
using namespace std;

template <typename T1, typename T2>
class A {
	T1 a;
	T2 b;
public:
	A() {}
	A(T1 x, T2 y) : a(x), b(y) {}
	A(const A& ob) { *this = ob; cout << "Copy ctor\n"; }
	A& operator = (const A& ob) { a = ob.a; b = ob.b; cout << "assignment operator\n"; }
	
    void Afis() const;
};

template <class T1, class T2>
void A<T1, T2>::Afis() const
{
	cout << a << " " << b << endl;
}


int main()
{
	A<const char*, const char*> a("Salut ", "rahatilor!"), x("I", "Robot");
	a.Afis();
	A<const char*, const char*> ob(x);
	ob.Afis();
	ob = a;
	A<double, char> b(5445.5445 , 'H');
	b.Afis();	
	typedef A<const char*, int> Elev;
	Elev eu("Georgica", 16);
	eu.Afis();
	system("pause");
	return 0;
}


