// Mostenirea claselor sablon (Constructori)
#include <iostream>
using namespace std;

template <class T1>
class A {
    T1 t1;
public:
    A();
    A(T1);
};

template <class T1>
A<T1>::A() : t1(0)
{
}

template <class T1>
A<T1>::A(T1 t) : t1(t)   // daca T1 e tip clasa *se apeleaza copyctor
{
}

template <class T1, class T2>
class B : public A<T1> {
    T2 t2;
public:
    B();
    B(T1 t1, T2 t2);
};

template <class T1, class T2>
B<T1, T2>::B(T1 t1, T2 t2) : A<T1>(t1), T2(t2)   // ????????
{
}

template <class T1, class T2>
B<T1, T2>::B() : A<T1>(), t2(0)
{
}

int main()
{
    B<double*, char> b;
}



