#ifndef __ARRAY_TEMPL__
#define __ARRAY_TEMPL__

#include <fstream.h>
using namespace std;

template <class T>
void Read(T a[], int &n, const char *s)
{
	ifstream fin(s);
	fin >> n;
	for ( int i = 0; i < n; i++ )
		fin >> a[i];
	fin.close();
}

template <class T>
void Write(T a[], int n, const char* s)
{
	ofstream fout(s);
	for ( int i = 0; i < n; i++ )
		fout << a[i] << " ";
	fout.close();
}

template <class T>
void Sort(T a[], int n)
{
	for ( int i = 0; i < n - 1; i++ )
		for ( int j = i + 1; j < n; j++ )
			if ( a[j] < a[i] )
			{
				T temp = a[i];
				a[i] = a[j];
				a[j] = temp;
			}

}

#endif
