#include <stdio.h>

#define MAXN 100100
#define MAXMOVES 560100

int N, K, M, A[MAXN], XOR, P[32], b[32], nzero;
int V[MAXMOVES][2];

void muta_fumeanu(void)
{
    int i, j, k;

    scanf("%d %d", &i, &j);
    
    XOR = XOR ^ A[i];
    for(k = 30; k >= 0; k--)
     if(A[i]&(1<<k))
        b[k]--;

    A[i] -= j, nzero += (A[i] == 0);

    XOR = XOR ^ A[i];
    for(k = 30; k >= 0; k--)
     if(A[i]&(1<<k))
        b[k]++;

    V[++K][0] = A[i], V[K][1] = i;
}

int find(int b)
{
    int i;

    for(i = P[b]; i <= K; i++)
     if( V[i][0] == A[V[i][1]] && (V[i][0]&(1<<b)) )
     {
        P[b] = i;
        return V[i][1];
     }
}

void muta_eu(void)
{
    int i, j, k, x, y, val, c, T;

    for(k = 30; k >= 0; k--)
     if(b[k]&1)
        break ;

    i = find(k), val = A[i];

    for(T = 0, c = 30; c > k; c--)
     if(val&(1<<c))
        T += (1<<c);

    for(k--; k >= 0; k--)
    {
        if(val&(1<<k))
        {
            if( (b[k]&1) == 0 )
                T += (1<<k);
        }
        else
        {
            if( b[k]&1 )
                T += (1<<k);
        }
    }

    j = A[i]-T;
    for(k = 30; k >= 0; k--)
     if(A[i]&(1<<k))
        b[k]--;

    A[i] = T;
    for(k = 30; k >= 0; k--)
     if(A[i]&(1<<k))
        b[k]++;

    nzero += (A[i] == 0);
    V[++K][0] = T, V[K][1] = i;

    printf("%d %d\n", i, j);
    fflush(stdout);
}

void ruleaza(void)
{
    int i, j, k, t;

    scanf("%d %d", &N, &M);

    for(k = 1; k <= N; k++)
    {
        scanf("%d %d", &i, &j), A[k] = j-i-1;
        nzero += (A[k] == 0);
        V[++K][0] = j-i-1, V[K][1] = k;
        for(t = 30; t >= 0; t--)
         if(A[k]&(1<<t))
            b[t]++;
        XOR = XOR ^ A[k];
    }

    for(t = 30; t >= 0; t--)
        P[t] = 1;

    while(1)
    {
        muta_eu();
        if(nzero == N)
            break ;
        muta_fumeanu();
        if(nzero == N)
            break ;
    }
}

int main(void)
{
    ruleaza();

    return 0;
}






    



    
    
    

































