#include <cstdio>
#include <vector>
#include <set>

using namespace std;

#define sz size()
#define pb push_back

#define Nmax 100005

int n, m, cnt;
int v[Nmax];
int rez;

set<int> H[31];

void readdata()
{
//    freopen("nakhla.in", "r", stdin);
//    freopen("nakhla.out", "w", stdout);

    int i, a, b;

    scanf("%d %d", &n, &m);
    for (i = 1; i <= n; ++i)
    {
        scanf("%d %d", &a, &b);
        v[i] = b-a-1;
        rez ^= v[i];
        if (v[i]) ++cnt;
    }
}

inline int bit(int k)
{
    int rez = 0;

    while (k)
    {
        ++rez;
        k >>= 1;
    }
    return rez-1;
}

inline void move(int val, int nr)
{
    printf("%d %d\n", val, nr);
    fflush(stdout);

    int aux, i;

    for (aux = v[val], i = 0; aux; aux >>= 1, ++i)
        if (aux & 1)
            H[i].erase( H[i].find(val) );
            
    v[val] -= nr;
    
    aux = v[val];
    for (aux = v[val], i = 0; aux; aux >>= 1, ++i)
        if (aux & 1)
            H[i].insert(val);

    if (v[val] == 0) --cnt;
}

inline void citeste()
{
    int a, b, i, aux;

    scanf("%d %d", &a, &b);

    rez = v[a] ^ (v[a]-b);

    for (aux = v[a], i = 0; aux; aux >>= 1, ++i)
        if (aux & 1)
            H[i].erase( H[i].find(a) );


    v[a] -= b;
    if (v[a] == 0) --cnt;

    for (aux = v[a], i = 0; aux; aux >>= 1, ++i)
        if (aux & 1)
            H[i].insert(a);
}

void solve()
{
    int i, j, x;
    int val, nr;
    int aux;

    for (i = 1; i <= n; ++i)
        for (aux = v[i], j = 0; aux; aux >>= 1, ++j)
            if (aux & 1)
                H[j].insert(i);
                
    val = *H[ bit(rez) ].begin();
    move(val, v[val] - (rez ^ v[val]));

    while (cnt)
    {
        citeste();
        val = *H[ bit(rez) ].begin();
        move(val, v[val] - (rez ^ v[val]));
    }
    
}

int main()
{
    readdata();
    solve();
    return 0;
}
