#include <cstdio>
#include <algorithm>

using namespace std;

#define x first
#define y second
#define mp make_pair

pair<int, int> p0, p1, p2, p3;
int a, b, x, y, z, M;
long long n;

void readdata()
{
    freopen("sir.in", "r", stdin);
    freopen("sir.out", "w", stdout);

    scanf("%d %d %d %d %d %d %d %d %lld", &p0.x, &p0.y, &a, &b, &x, &y, &z, &M, &n);
}

inline void pas(pair<int, int> &p)
{
    int nou;

    nou = ( (((a*p.x)%M) * p.x) + (((b*p.y)%M) * p.y) ) %M;
    nou += x*p.x + y*p.y + z;
    if (nou >= M) nou %= M;

    p.x = p.y;
    p.y = nou;
}

void ciobaneala()
{
    int i, ax = n;
    pair<int, int> aux = p0;

    if (ax == 0)
    {
        printf("%d\n", p0.x);
        return;
    }

    for (i = 1; i < ax; ++i)
        pas(aux);
    printf("%d\n", aux.y);
}

void solve()
{
    int i;
    int lung = 1, d = 0;
    int nr = 0;

    p0.x %= M; p0.y %= M;
    p2 = p1 = p0;

//    ciobaneala();

    pas(p1);
    pas(p2); pas(p2);

    while (p1 != p2)
    {
        pas(p1);
        pas(p2); pas(p2);
    }

    pas(p2);
    if (p2 != p1)
    {
        while ( p2 != p1)
        {
            ++lung;
            pas(p2);
        }
    }

    p2 = p0;
    while (p2 != p1)
    {
        ++d;
        pas(p2);
    }

    p2 = p1;
    int stop = lung - (d%lung);
    for (i = 1; i <= stop; ++i)
        pas(p2);

    p3 = p0;
    while (p3 != p2)
    {
        pas(p3); pas(p2);
        ++nr;
    }
    
    if ((long long)(nr+1) >= n)
    {
        ciobaneala();
        return;
    }
    
    n -= (long long)(nr+1);
    n %= (long long)lung;
    int aux = n;
    for (i = 1; i <= aux; ++i)
        pas(p3);
    printf("%d\n", p3.y);
}

int main()
{
    readdata();
    solve();
    return 0;
}
