#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define nmax 1024
#define max(a,b) (a>b?a:b)
#define min(a,b) (a<b?a:b)

struct nod
{
    int x,y,d;
    nod *n;
};

const int dx[]={ 0, 0, 1,-1};
const int dy[]={ 1,-1, 0, 0};
int n,k,i,j,d[nmax][nmax],x,y,lo,hi,mid;
char v[nmax][nmax];
nod *f,*l,*aux;

int merge(int dist)
{
    int mi1=2*n,mi2=2*n,ma1=0,ma2=0,i,j,s1,s2;

    for (i=0;i<n;i++)
        for (j=0;j<n;j++)
            if (d[i][j]>dist)
            {
                s1=i+j,s2=n-i+j;
                mi1=min(mi1,s1);ma1=max(ma1,s1);
                mi2=min(mi2,s2);ma2=max(ma2,s2);
            }
    ma1-=mi1,ma2-=mi2;
    if ((ma1<0)||(ma2<0))
        return 1;
    ma1=ma1/2+ma1%2;
    ma2=ma2/2+ma2%2;
    if ((ma1<=dist)&&(ma2<=dist))
        return 1;
    return 0;
}

int main()
{
    freopen("centru.in","r",stdin);
    freopen("centru.out","w",stdout);

    scanf("%d%d",&n,&k);
    l=f=new nod;
    scanf("%d%d",&y,&x);
    l->x=x,l->y=y,l->d=0,l->n=NULL;
    v[x][y]=1;
    for (i=1;i<k;i++)
    {
        scanf("%d%d",&y,&x);
        l->n=new nod;
        l=l->n,l->x=x,l->y=y,l->d=0,l->n=NULL;
        v[x][y]=1;
    }

    for (;f!=NULL;)
    {
        x=f->x,y=f->y;
        for (i=0;i<4;i++)
            if ((x+dx[i]>=0)&&(y+dy[i]>=0)&&(x+dx[i]<n)&&(y+dy[i]<n)&&(!v[x+dx[i]][y+dy[i]]))
            {
                d[x+dx[i]][y+dy[i]]=f->d+1,v[x+dx[i]][y+dy[i]]=1;
                l->n=new nod;
                l=l->n,l->x=x+dx[i],l->y=y+dy[i],l->d=f->d+1,l->n=NULL;
            }
        aux=f,f=f->n;
        delete aux;
    }

    lo=0,hi=n+5;
    while (lo+1<hi)
    {
        mid=(lo+hi)/2;
        if (merge(mid))
            hi=mid;
        else
            lo=mid+1;
    }
    if (!merge(lo))
        ++lo;
    printf("%d\n",lo);

    return 0;
}

