#include <cstdio>

#define LMAX 100005
#define CMAX 31
int INTERV_MAX=262144;

int M,N,S=0;
int alb[LMAX],negru[LMAX];
int *ARB[CMAX];
int cnt=0;

void read_data()
  {
   scanf("%d %d",&M,&N);
   for(int i=1;i<=M;i++)
      scanf("%d %d",&alb[i],&negru[i]);
  }

void build(int n, int i, int mask, int li, int ls)
  {
   if(li==ls)
     {
      int aux=negru[li]-alb[li]-1;
      if(aux&mask)
        ARB[i][n]=li;
      else
        ARB[i][n]=-1;
      return;
     }
   build(2*n,i,mask,li,(li+ls)/2);
   build(2*n+1,i,mask,(li+ls)/2+1,ls);
   ARB[i][n]=ARB[i][2*n];
   if(ARB[i][n]==-1)
     ARB[i][n]=ARB[i][2*n+1];
  }

void init()
  {
   int i;
   while(INTERV_MAX>=4*M)
        INTERV_MAX>>=1;
   for(i=CMAX-2;i>=0;--i)
      {
       ARB[i]=new int[INTERV_MAX];
       build(1,i,1<<i,1,M);
      }
   for(i=1;i<=M;i++)
      {
       if(negru[i]!=alb[i]+1)
         cnt++;
       S^=(negru[i]-alb[i]-1);
      }
  }

void erase_arb(int n, int i, int li, int ls, int lin)
  {
   if(li==ls)
     {
      ARB[i][n]=-1;
      return;
     }
   if(lin<=(li+ls)/2)
     erase_arb(2*n,i,li,(li+ls)/2,lin);
   else
     erase_arb(2*n+1,i,(li+ls)/2+1,ls,lin);
   ARB[i][n]=ARB[i][2*n];
   if(ARB[i][n]==-1)
     ARB[i][n]=ARB[i][2*n+1];
  }

void update_arb(int n, int i, int mask, int li, int ls, int lin)
  {
   if(li==ls)
     {
      int aux=negru[li]-alb[li]-1;
      if(aux&mask)
        ARB[i][n]=li;
      else
        ARB[i][n]=-1;
      return;
     }
   if(lin<=(li+ls)/2)
     update_arb(2*n,i,mask,li,(li+ls)/2,lin);
   else
     update_arb(2*n+1,i,mask,(li+ls)/2+1,ls,lin);
   ARB[i][n]=ARB[i][2*n];
   if(ARB[i][n]==-1)
     ARB[i][n]=ARB[i][2*n+1];
  }

void erase(int lin)
  {
   for(int i=CMAX-2;i>=0;--i)
      erase_arb(1,i,1,M,lin);
  }

void update(int lin)
  {
   for(int i=CMAX-2;i>=0;--i)
      update_arb(1,i,1<<i,1,M,lin);
  }

inline int cmsb(int x)
  {
   if(x==1)
     return 0;
   else
     return 1+cmsb(x/2);
  }

void solve()
  {
   int lin,dif,oldS,ramane;
   do{
      // mutarea mea
      lin=ARB[cmsb(S)][1];
      erase(lin);
      ramane=S^(negru[lin]-alb[lin]-1);
      dif=(negru[lin]-alb[lin]-1)-ramane;
      printf("%d %d\n",lin,dif);
      fflush(stdout);
      alb[lin]+=dif;
      update(lin);
      if(negru[lin]==alb[lin]+1)
        cnt--;
      // mutarea lui
      if(cnt)
        {
         scanf("%d %d",&lin,&dif);
         erase(lin);
         oldS=negru[lin]-alb[lin]-1;
         negru[lin]-=dif;
         S=oldS^(negru[lin]-alb[lin]-1);
         update(lin);
         if(negru[lin]==alb[lin]+1)
           cnt--;
        }
     }while(cnt);
  }


int main()
{
read_data();
init();
solve();
return 0;
}
