#include <cstdio>
int T0,T1,a,b,x,y,z,M;
long long n;
int VAL1,VAL2;
int poz;

void solve(int n)
  {
   int val1,val2,val3;
   int p1,p2;
   val1=T0;
   val2=T1;
   p1=(val1*val1)%M;
   p2=(val2*val2)%M;
   for(int i=2;i<=n;++i)
      {
       val3=(a*p1+b*p2+x*val1+y*val2+z)%M;
       p1=p2;
       p2=(val3*val3)%M;
       val1=val2;
       val2=val3;
      }
   VAL1=val1;
   VAL2=val2;
  }

void find(int n)
  {
   int val1,val2,val3;
   int p1,p2;
   val1=T0;
   val2=T1;
   p1=(val1*val1)%M;
   p2=(val2*val2)%M;
   for(int i=2;i<=n;++i)
      {
       //val3=(val1*((a*val1+x)%M)+val2*((b*val2+y)%M)+z)%M;
       val3=(a*p1+b*p2+x*val1+y*val2+z)%M;
       p1=p2;
       p2=(val3*val3)%M;
       val1=val2;
       val2=val3;
      }
   VAL1=val1;
   VAL2=val2;
  }

void search(int n)
  {
   int val1,val2,val3;
   int p1,p2;
   val1=T0;
   val2=T1;
   p1=(val1*val1)%M;
   p2=(val2*val2)%M;
   for(int i=2;i<n;++i)
      {
       val3=(a*p1+b*p2+x*val1+y*val2+z)%M;
       p1=p2;
       p2=(val3*val3)%M;
       if(val3==VAL2 && val2==VAL1)
         poz=i;
       val1=val2;
       val2=val3;
      }
  }

void solve2(int max, int n)
  {
   int val1,val2,val3=-1;
   int p1,p2;
   val1=VAL1;
   val2=VAL2;
   p1=(val1*val1)%M;
   p2=(val2*val2)%M;
   for(int i=max+1;i<=n;++i)
      {
       val3=(a*p1+b*p2+x*val1+y*val2+z)%M;
       p1=p2;
       p2=(val3*val3)%M;
       val1=val2;
       val2=val3;
      }
   if(max<n)
     VAL2=val3;
  }


int main()
{
freopen("sir.in","r",stdin);
freopen("sir.out","w",stdout);

scanf("%d %d %d %d %d %d %d %d %Ld",&T0,&T1,&a,&b,&x,&y,&z,&M,&n);
T0%=M;
T1%=M;
a%=M;
b%=M;
x%=M;
y%=M;
z%=M;
int max=M*M+5;
if(n<=max || n<=7000*7000)
  {
   solve(n);
   printf("%d\n",VAL2);
   return 0;
  }
if(max>7000*3500)
  max=7000*3500;
find(max);
search(max);
int per=max-poz;
n=max+((n-max)%per);
solve2(max,n);
printf("%d\n",VAL2);

return 0;
}
