#include <cstdio>
#include <cstring>
#include <algorithm>

using namespace std;

#define Nmax 512
#define INF 0x3f3f3f3f
#define mp make_pair
#define x first
#define y second

const int dx[4] = {0, 1, 0, -1};
const int dy[4] = {1, 0, -1, 0};
int n, k, st, dr, ct;
int mat[Nmax][Nmax];
pair<int, int> c[Nmax * Nmax], sir[Nmax * Nmax], ord[Nmax * Nmax];

void citire()
{
    int i, a, b;

    scanf("%d %d\n", &n, &k);
    for (i = 1; i <= k; ++i)
    {
    	scanf("%d %d\n", &a, &b);
        sir[i] = mp(a, b);
    }
}

inline int ok(int x)
{
	return (0 <= x && x < n);
}

int cmp(const pair<int, int> a, const pair<int, int> b)
{
	return mat[a.x][a.y] > mat[b.x][b.y];
}

void init()
{
	int i, j;

    for (i = 0; i < n; ++i)
    	for (j = 0; j < n; ++j)
        	mat[i][j] = INF;
}

void solve()
{
	int posx, posy, i, j, x0, y0, d, sol = INF, lim;
    pair<int, int> nod;

    init();
   	for (i = 1; i <= k; ++i)
	{
    	c[i] = sir[i];
        mat[c[i].x][c[i].y] = 0;
    }
	dr = k;
    st = 0;

    while (st < dr)
    {
    	nod = c[++st];
        for (d = 0; d < 4; ++d)
        {
        	x0 = nod.x + dx[d];
            y0 = nod.y + dy[d];
            if (ok(x0) && ok(y0) && mat[x0][y0] == INF)
            {
            	c[++dr] = mp(x0, y0);
                mat[x0][y0] = mat[nod.x][nod.y] + 1;
            }
        }
    }

	for (i = 0; i < n; ++i)
    	for (j = 0; j < n; ++j)
            ord[++ct] = mp(i, j);
    sort(ord+1, ord+ct+1, cmp);

    lim = 50 * 50 * 50 * 50;
    lim /= n * n;
    if (lim > ct) lim = ct;

    for (j = 1; j <= lim; ++j)
        {
        	posx = ord[j].x;
            posy = ord[j].y;
            
        	init();
	    	for (i = 1; i <= k; ++i)
            {
    			c[i] = sir[i];
                mat[c[i].x][c[i].y] = 0;
            }
            dr = k;
            c[++dr] = mp(posx, posy);
            mat[posx][posy] = 0;
            st = 0;
            
            while (st < dr)
            {
            	nod = c[++st];
                for (d = 0; d < 4; ++d)
                {
                	x0 = nod.x + dx[d];
                    y0 = nod.y + dy[d];
                    if (ok(x0) && ok(y0) && mat[x0][y0] == INF)
                    {
                        c[++dr] = mp(x0, y0);
                        mat[x0][y0] = mat[nod.x][nod.y] + 1;
                    }
                }
                if (mat[c[dr].x][c[dr].y] >= sol) break;
            }
			if (mat[c[dr].x][c[dr].y] < sol)
            	sol = mat[c[dr].x][c[dr].y];
        }

    printf("%d\n", sol);
}

int main()
{
	freopen("centru.in", "r", stdin);
    freopen("centru.out", "w", stdout);
    citire();
    solve();
    return 0;
}
