#include <stdio.h>
#include <string>

#define ll long long
#define maxl 3

int c0,c1,c2,a,b,x,y,z,mod;
ll n;
int c[maxl][maxl],aux[maxl][maxl],mat[maxl][maxl];

void power(ll x)
{
     int i,j,k;

     if (x==0)
        for (i=1;i<maxl;i++) c[i][i]=1;
     else if (x%2==0)
          {
              power(x/2);

              memset(aux,0,sizeof(aux));
              for (i=1;i<maxl;i++)
                for (j=1;j<maxl;j++)
                  for (k=1;k<maxl;k++)
                  {
                      aux[i][j]+=c[i][k]*c[k][j];
                      aux[i][j]%=mod;
                  }

              memcpy(c,aux,sizeof(c));
          }
          else {
                   power(x-1);

                   memset(aux,0,sizeof(aux));
                   for (i=1;i<maxl;i++)
                     for (j=1;j<maxl;j++)
                       for (k=1;k<maxl;k++)
                       {
                           aux[i][j]+=c[i][k]*mat[k][j];
                           aux[i][j]%=mod;
                       }

                   memcpy(c,aux,sizeof(aux));
               }
}

int main()
{
    freopen("sir.in","r",stdin);
    freopen("sir.out","w",stdout);

    scanf("%d %d %d %d %d %d %d %d %lld",&c0,&c1,&a,&b,&x,&y,&z,&mod,&n);

    int i;

    c0%=mod;
    c1%=mod;
    if ((a==0) && (b==0))
    {
        mat[1][1]=0;
        mat[2][1]=1;
        mat[1][2]=x;
        mat[2][2]=y;
        power(n);
        c2=(c0*c[1][1]+c1*c[2][1]+(z%mod)*(n%mod))%mod;
        printf("%d\n",c2);
        return 0;
    }

    if (n==0) printf("%d\n",c0);
    else if (n==1) printf("%d\n",c1);
    else {
             for (i=2;i<=n;i++)
             {
                c2=(1LL*a*c0*c0+1LL*b*c1*c1+x*c0+y*c1+z)%mod;
                c0=c1;
                c1=c2;
             }

             printf("%d\n",c2);
         }

    return 0;
}
