#include <cstdio>
#include <set>

using namespace std;

#define MP make_pair
#define x first
#define y second

const int NMAX = 1 << 17;

int N, M;
set <pair <int, int> > S;
int V[NMAX];

int main(void) {
	int i, u, v, r = 0, t = 0;

	scanf(" %d %d", &N, &M);

	for (i = 1; i <= N; ++i) {
		scanf(" %d %d", &u, &v);
		if (u + 1 != v)
			S.insert(MP(v - u - 1, i));
		V[i] = v - u - 1;
		r ^= V[i];
	}

	set <pair <int, int> > :: iterator it;

	while (!S.empty()) {

		it = S.upper_bound(MP(r, 0));
		
		if (it->x != r)
			for (it = --S.end(); (r ^ it->x) >= it->x; --it);
			
		t = it->x - (r ^ it->x);
		r = r ^ it->x ^ (it->x - t);

		u = it->y;
		
		printf("%d %d\n", u, t);
		fflush(stdout);
		
		S.erase(it);
		V[u] -= t;
		if (V[u] != 0)
			S.insert(MP(V[u], u));
			
		if (S.empty()) continue;

		scanf(" %d %d", &u, &v);
		
		S.erase(MP(V[u], u));

		r = r ^ V[u] ^ (V[u] - v);
		V[u] -= v;

		if (V[u] != 0)
			S.insert(MP(V[u], u));
	}

	return 0;
}

