#include <cstdio>

#define NMAX 155
int a[NMAX][NMAX],s[NMAX][NMAX];
int M,N;
int SOL=0;

void read_data()
  {
   scanf("%d %d",&M,&N);
   for(int i=1;i<=M;i++)
      for(int j=1;j<=N;j++)
         {scanf("%d",&a[i][j]);
          a[i][j]=1-a[i][j];};
  }

void init()
  {
   for(int i=1;i<=M;i++)
      for(int j=1;j<=N;j++)
         {
          s[i][j]=a[i][j];
          if(i>1)
            s[i][j]+=s[i-1][j];
          if(j>1)
            s[i][j]+=s[i][j-1];
          if(i>1 && j>1)
            s[i][j]-=s[i-1][j-1];
         }
  }

inline int liber(int l1, int c1, int l2, int c2)
  {
   int x=s[l2][c2];
   if(l1>1)
     x-=s[l1-1][c2];
   if(c1>1)
     x-=s[l2][c1-1];
   if(l1>1 && c1>1)
     x+=s[l1-1][c1-1];
   return x==(l2-l1+1)*(c2-c1+1);
  }

inline int lb(int l1, int c1, int l2, int c2)
  {
   return (l2-l1+1)*(c2-c1+1);
  }

void brute()
  {
   int lin1,lin2,col1,col2,i,j1,j2,ii,jj1,jj2;

   for(lin1=1;lin1<=M;lin1++)
      for(lin2=lin1;lin2<=M;lin2++)
         for(col1=1;col1<=N;col1++)
            for(col2=col1;col2<=N;col2++)
               if(liber(lin1,col1,lin2,col2))
                 for(i=lin2+1;i<=M;i++)
                    for(j1=col1+1;j1<col2;j1++)
                       for(j2=j1;j2<col2;j2++)
                          if(liber(lin2+1,j1,i,j2))
                            for(ii=i+1;ii<=M;ii++)
                               for(jj1=1;jj1<j1;jj1++)
                                  for(jj2=j2+1;jj2<=N;jj2++)
                                     if(liber(i+1,jj1,ii,jj2))
                                     {int aux=lb(lin1,col1,lin2,col2)+
                                     lb(lin2+1,j1,i,j2)+
                                     lb(i+1,jj1,ii,jj2);
                                     if(aux>SOL)
                                       SOL=aux;
                                       }
  }


int main()
{
freopen("imax.in","r",stdin);
freopen("imax.out","w",stdout);

read_data();
init();
brute();

printf("%d\n",SOL);

return 0;
}
