#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

#define Nmax 2705
#define mod 666013
#define pb push_back
#define sz size()

int n, m, sol;
int h[Nmax], list[Nmax];
vector<int> lv[Nmax];
int mat[Nmax][Nmax];

void citire()
{
	int i, a, b;

    scanf("%d %d\n", &n, &m);
    for (i = 1; i <= n; ++i)
    	scanf("%d", &h[i]);
    for (i = 1; i <= m; ++i)
    {
    	scanf("%d %d\n", &a, &b);
        lv[a].pb(b);
    }
}

int cmp(const int a, const int b)
{
	return h[a] > h[b];
}

void solve()
{
    int i, j, k, nod, put;

    for (i = 1; i <= n; ++i) list[i] = i;
    
    sort(list+1, list+n+1, cmp);

    /*
    for (i = 1; i <= n; ++i)
    	printf("%d ", list[i]);
    printf("\n");
    */

    for (i = 1; i <= n; ++i)
    {
    	nod = list[i];
    	mat[nod][nod] = nod;
        for (j = 0; j < lv[nod].sz; ++j)
        {
            for (k = 1; k <= n; ++k)
            {
            	if (mat[nod][k] == 0)
                	mat[k][nod] = mat[nod][k] = mat[lv[nod][j]][k];
                else if (mat[lv[nod][j]][k] != 0 && h[mat[lv[nod][j]][k]] < h[mat[nod][k]])
                	mat[k][nod] = mat[nod][k] = mat[lv[nod][j]][k];
            }
        }
    }

    put = 1;
    for (i = n; i >= 1; --i)
    	for (j = n; j > i; --j)
        {
        	//printf("%d %d - %d\n", i, j, mat[i][j]);
            if (put >= mod) put %= mod;
            sol = sol + put * mat[i][j];
            if (sol >= mod) sol %= mod;
            put *= n + 1;
        }
        
    printf("%d\n", sol);
}
    

int main()
{
	freopen("casute.in", "r", stdin);
    freopen("casute.out", "w", stdout);
    citire();
    solve();
    return 0;
}
