#include <stdio.h>
#include <vector>
#include <algorithm>

using namespace std;

#define maxn 3010
#define maxx 110
#define mod 666013
#define pb push_back
#define max(a,b) (a>b ? a:b)

int n,m,l,sol;
int h[maxn],p[maxn],g[maxn],g2[maxn],q[maxn];
vector <int> a[maxn],b[maxn];
int grad[maxn],s[maxn];
unsigned int c[maxn][maxx];
int d[maxn];

int cmp(int x,int y)
{
    return h[x]<h[y];
}

int marked(int x,int y)
{
    y--;
    return (c[x][y/32]&(1<<(y&31)))!=0;
}

void mark(int x,int y)
{
     y--;
     c[x][y/32]+=(1<<(y&31));
}

int count(int x)
{
    int i;
    for (i=0;i<32;i++)
      if ((x&(1<<i))!=0) return (i+1);
}

int main()
{
    freopen("casute.in","r",stdin);
    freopen("casute.out","w",stdout);

    int i,x,y,aux,j,k,found;
    
    scanf("%d %d ",&n,&m);
    for (i=1;i<=n;i++) scanf("%d ",&h[i]);

    for (i=1;i<=m;i++)
    {
       scanf("%d %d ",&x,&y);
       a[x].pb(y);
       grad[x]++;
       b[y].pb(x);
    }

    for (i=1;i<=n;i++)
    {
        g[i]=a[i].size();
        g2[i]=b[i].size();
        p[i]=i;
    }

    sort(p+1,p+n+1,cmp);

    for (i=1;i<=n;i++) q[p[i]]=i;

    for (i=1;i<=n;i++)
      if (grad[i]==0)
      {
         l++;
         s[l]=i;
      }

    for (i=1;i<=n;i++) mark(i,q[i]);

    for (i=1;i<=l;i++)
    {
       for (j=0;j<g2[s[i]];j++)
       {
           aux=b[s[i]][j];
           grad[aux]--;
           if (grad[aux]==0) s[++l]=aux;

           for (k=0;k<=n/32+1;k++) c[aux][k]|=c[s[i]][k];
       }
    }

    for (i=1;i<=n;i++)
      for (j=0;j<=n/32+1;j++)
        if (c[i][j]!=0)
        {
           d[i]=j;
           break;
        }

    for (i=1;i<=n;i++)
      for (j=i+1;j<=n;j++)
         if (marked(i,q[j]))
         {
             sol=(sol*(n+1)+j)%mod;
//             printf("%d\n",j);
         }
         else if (marked(j,q[i]))
              {
                 sol=(sol*(n+1)+i)%mod;
//                 printf("%d\n",i);
              }
              else {
                      found=0;
                      for (k=max(d[i],d[j]);k<=n/32+1;k++)
                      {
                         aux=c[i][k]&c[j][k];
                         if (aux!=0)
                         {
                            aux=p[k*32+count(aux)];
                            sol=(sol*(n+1)+aux)%mod;
                            found=1;
//                            printf("%d\n",aux);
                            break;
                         }
                      }
                      if (!found)
                      {
                         sol=(sol*(n+1))%mod;
//                        printf("0\n");
                      }
                   }

    printf("%d\n",sol);

    return 0;
}
