#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

#define MAXN 3005
#define MOD 666013

int N, M;
int h[MAXN], o[MAXN], bst[MAXN][MAXN];
vector<int> con[MAXN];

int cmp( int a, int b ) { return h[a] > h[b]; }

int main()
{
	freopen("casute.in", "rt", stdin);
	freopen("casute.out", "wt", stdout);

	scanf("%d %d", &N, &M);
	h[0] = 0x3f3f3f3f;
	for (int i = 1; i <= N; i++)
		scanf("%d", h + i),
		o[i] = i,
		bst[i][i] = i;

	for (int i = 0; i < M; i++)
	{
		int a, b;
		scanf("%d %d", &a, &b);
		con[a].push_back(b);
	}
	sort( o + 1, o + N + 1, cmp );

	for (int a = 1; a <= N; a++)
		for (int b = a + 1; b <= N; b++)
		{
			int i = o[a], j = o[b];

			bst[i][j] = bst[j][i] = 0;
			vector<int> :: iterator it;
			for (it = con[i].begin(); it != con[i].end(); it++)
				if (h[ bst[*it][j] ] < h[ bst[i][j] ])
					bst[i][j] = bst[*it][j];

			for (it = con[j].begin(); it != con[j].end(); it++)
				if (h[ bst[i][*it] ] < h[ bst[i][j] ])
					bst[i][j] = bst[i][*it];

			bst[j][i] = bst[i][j];
		}

	long long REZ = 0;
	for (int i = 1; i <= N; i++)
		for (int j = i + 1; j <= N; j++)
		{
			REZ *= N + 1; REZ %= MOD;
			REZ += bst[i][j]; REZ %= MOD;
		}
	printf("%lld\n", REZ);
	
	return 0;
}
