#include <stdio.h>

#define MAXN 152

int N, M;
char m[MAXN][MAXN];
unsigned short up[MAXN][MAXN], down[MAXN][MAXN], s[MAXN][MAXN];
unsigned short a[MAXN][MAXN][MAXN], b[MAXN][MAXN][MAXN];

int main()
{
	freopen("imax.in", "rt", stdin);
	freopen("imax.out", "wt", stdout);

	scanf("%d %d", &N, &M);

	for (int i = 1; i <= N; i++)
		for (int j = 1; j <= M; j++)
		{
			scanf(" %c", m[i] + j);
			m[i][j] -= '0';
			s[i][j] = s[i - 1][j] + s[i][j - 1] - s[i - 1][j - 1] + m[i][j];
			up[i][j] = (!m[i][j]) * (up[i - 1][j] + 1);
		}

	for (int i = N; i >= 1; i--)
		for (int j = 1; j <= M; j++)
			down[i][j] = (!m[i][j]) * (down[i + 1][j] + 1);

	for (int r = 1; r <= N; r++)
	{
		for (int c1 = 1; c1 <= M; c1++)
		{
			int MINup = 0x3f3f3f3f, MINdown = 0x3f3f3f3f;
			for (int c2 = c1; c2 <= M; c2++)
			{
				if (up[r][c2] < MINup)
					MINup = up[r][c2];
				a[r][c1][c2] = MINup * (c2 - c1 + 1);
				if (down[r][c2] < MINdown)
					MINdown = down[r][c2];
				b[r][c1][c2] = MINdown * (c2 - c1 + 1);
			}
		}

		for (int c1 = 1; c1 <= M; c1++)
			for (int c2 = M; c2 >= c1; c2--)
			{
				if (c1 > 1)
				{
					if (a[r][c1 - 1][c2] > a[r][c1][c2])
						a[r][c1][c2] = a[r][c1 - 1][c2];
					if (b[r][c1 - 1][c2] > b[r][c1][c2])
						b[r][c1][c2] = b[r][c1 - 1][c2];
				}
				
				if (c2 < M)
				{
					if (a[r][c1][c2 + 1] > a[r][c1][c2])
						a[r][c1][c2] = a[r][c1][c2 + 1];
					if (b[r][c1][c2 + 1] > b[r][c1][c2])
						b[r][c1][c2] = b[r][c1][c2 + 1];
				}
			}
	}

	int MAX = -0x3f3f3f3f;

	for (int r1 = 2; r1 < N; r1++)
		for (int r2 = r1; r2 < N; r2++)
		{
			if (s[r2][M] - s[r1 - 1][M] == (r2 - r1 + 1) * M)
				continue;
			for (int c1 = 2; c1 < M; c1++)
			{
				if (m[r1][c1])
					continue;
				for (int c2 = c1; c2 < M; c2++)
				{
					int S = s[r2][c2] - s[r1 - 1][c2] - s[r2][c1 - 1] + s[r1 - 1][c1 - 1];
					if (S)
						continue;

					int VAL = (r2 - r1 + 1) * (c2 - c1 + 1) + a[r1 - 1][c1 - 1][c2 + 1] + b[r2 + 1][c1 - 1][c2 + 1];
					if (VAL > MAX)
						MAX = VAL;
				}
			}
		}

	printf("%d\n", MAX);
	return 0;
}
