#include <stdio.h>
#include <string.h>
#define NMAX 2000
#define MOD 666013
typedef struct sod
{
   int x, h;
};
sod nod[NMAX];
int n, m;
int h[NMAX];
int ok[NMAX][NMAX];
int a[NMAX][NMAX];

void read()
{
   int i, x ,y, max, min;
   scanf("%d %d", &n, &m);
   for(i = 1; i <= n; ++i)
   {
      scanf("%d", &nod[i].h);
      h[i] = nod[i].h;
      nod[i].x = i;
   }
   for(i = 1; i <= m; ++i)
   {
      scanf("%d %d", &x, &y);
      min = x;
      max = y;
      if(h[x] > h[y])
              min = y, max = x;
      
      a[min][ ++a[min][0] ] = max;
   }
}

void do_bf(int x)
{
   int c[NMAX], initial = x;
   int viz[NMAX];
   int inc, sf, i;
   memset(viz, 0, sizeof(viz));
   inc = sf = 1;
   c[inc] = x;

   while(inc <= sf)
   {
      x = c[inc++];
      for(i = 1; i <= a[x][0]; ++i)
      {
         if(!viz[ a[x][i] ])
         {
            viz[ a[x][i] ] = 1;
            ok[initial][ a[x][i] ] = 1;
            c[++sf] = a[x][i];
         }
      }
   }
}
int low(int x, int y)
{
   int i;
   for(i = 1; i <= n; ++i)
   {
      if(ok[x][i] && ok[y][i])
                  return i;
   }
   return 0;
}

int main()
{
   int i, j, pow = 1, nr = 0;
   freopen("casute.in", "r", stdin);
   freopen("casute.out", "w", stdout);

   read();

   for(i = 1; i <= n; ++i)
           do_bf(i), ok[i][i] = 1;
   for(i = 1; i <= n; ++i)
   {
      for(j = i+1; j <= n; ++j)
      {
         printf("%d\n", low(i, j));
         //pow *= n+1;
         //if(pow >= MOD)
           //     pow %= MOD;
      }
   }
   //printf("%d\n", nr);
   
   fclose(stdin);
   fclose(stdout);
   return 0;
}







