# include <stdio.h>
# include <string.h>

# define  _fin  "casute.in"
# define  _fout "casute.out"

# define  maxn  1001
# define  maxm  30003

# define  mod   666013

# define  myint long long


short int b[maxn][maxn];


int *v[maxn], bx[maxm], by[maxm], dg[maxn];
int n, m;
int h[maxn];


void readf()
{
    int i, j;

    freopen(_fin, "r", stdin);

    for (scanf("%d%d", &n, &m), i=1; i<=n; ++i)
        scanf("%d", h+i);

    for (i=1; i<=m; ++i) {
        scanf("%d%d", bx+i, by+i), ++dg[bx[i]], ++dg[by[i]];

        if ( h[ bx[i] ] < h[ by[i] ] )
            bx[i] ^= by[i] ^= bx[i] ^= by[i];
    }
    
    for (i=1; i<=n; ++i)
        v[i] = new int[ dg[i]+1 ], v[i][0]=0;

    for (i=1; i<=m; ++i)
        v[bx[i]][++v[bx[i]][0]] = by[i],
        v[by[i]][++v[by[i]][0]] = bx[i];
}

int s[maxn], c, i, j, x;
int viz[maxn];

int l1, l2;

void solve()
{
    for (i=1; i<=n; ++i) {
        s[0]=0;

        memset(viz, 0, sizeof(viz));

        for (j=1; j<=v[i][0]; ++j)
            if ( h[ i ] > h[ v[i][j] ] )
                b[i][ v[i][j] ] = b[v[i][j]][i] = i,
                s[++s[0]] = v[i][j],
                viz[ v[i][j] ] = 1;

        for (c=1; c<=s[0]; ++c)
            for (x=s[c], j=1; j<=v[x][0]; ++j)
                if ( h[x] > h[ v[x][j] ] && !viz[ v[x][j] ]) {
                    b[i][ v[x][j] ] = b[ v[x][j] ][i] = i;
                    viz[ v[x][j] ] = 1;
                    s[++s[0]] = v[x][j];
                }
    }

    int h1, h2, h3, hx;

    for (i=1; i<=n; ++i)
        for (j=1; j<=n; ++j) {

            if ( b[i][j] ) continue;

            for (l1=1; l1<=v[i][0]; ++l1)
                for (l2=1; l2<=v[j][0]; ++l2) {
                    if ( v[i][l1] == v[j][l2] )
                        b[i][j] = v[i][l1];
//                    else {

                        hx=h[ b[i][j] ];

                        if ( b[i][ v[j][l2] ] &&
                            h[ b[i][ v[j][l2] ] ] < hx )
                            hx = h[ b[i][ v[j][l2] ] ],
                            b[i][j] = b[j][i] = b[i][ v[j][l2] ];

                        if ( b[ v[i][l1] ][j] &&
                            h[ b[ v[i][l1] ][j] ] < hx )
                            hx = h[ b[ v[i][l1] ][j] ],
                            b[i][j] = b[j][i] = b[ v[i][l1] ][j];

                        if ( b[ v[i][l1] ][ v[j][l2] ] &&
                            h[ b[v[i][l1]][ v[j][l2] ] ] < hx)
                            b[i][j] = b[j][i] = b[ v[i][l1] ][ v[i][l2] ];
//                    }
                }
                
        }
}

int main()
{
    readf();
    solve();

    myint sol=0, pow=1;

    for (i=1; i<n; ++i)
        for (j=i+1; j<=n; ++j)
            sol = ( sol * (n+1) + b[i][j] ) % mod;

    freopen(_fout, "w", stdout);
    printf("%d\n", sol);

    return 0;
}
