# include <stdio.h>
# include <math.h>
# include <string.h>

# define  _fin  "imax.in"
# define  _fout "imax.out"

# define  maxn  151


int a[maxn][maxn], c0[maxn][maxn], n, m;  // c0 = count0

int ur[maxn][maxn][3], nu[maxn];    // stanga, dreapta, sus
int lr[maxn][maxn][3], nl[maxn];
int c[maxn][2],  nc;    // coloanele

# define  n0(x1,y1,x2,y2) ( c0[x2][y2]-c0[x2][y1-1]-c0[x1-1][y2]+c0[x1-1][y1-1] )

int sol;
int i, j, k;


void readf()
{
    freopen(_fin, "r", stdin);

    for (scanf("%d%d", &n, &m), i=1; i<=n; ++i)
        for (j=1; j<=m; ++j)
            scanf("%d", &a[i][j]),
            c0[i][j] = c0[i][j-1] + c0[i-1][j] - c0[i-1][j-1] + !a[i][j];
}

int l1, l2, x;

int d[maxn], h, t, x0[maxn];

# define    min(x, y)   (x<y?x:y)
# define    max(x, y)   (x>y?x:y)


void solve()
{
    int minh, oldt;

    for (l1=n; l1>=3; --l1)
    {
        h = 1, t = 0;
        nu[l1] = 0; // number of up - rectangles

        for (x=1; x<=m; ++x) {
            if ( a[l1][x] ) {
                x0[x] = 0;

                minh = x0[d[t]];

                for (j=d[t]; t>=h; --t) {

                    if ( j-d[t] >= 2 && ( minh > x0[d[t-1]] || t==h ) )  {
                        if ( x0[d[t]] < minh ) minh = x0[d[t]];
                    
                        ur[l1][++nu[l1]][0] = d[t],
                        ur[l1][nu[l1]][1] = j,
                        ur[l1][nu[l1]][2] = minh;
                    }

                    if ( x0[d[t]] < minh ) minh = x0[d[t]];
                }

                h=1, t=0;
            }
            
            else {
                ++x0[x];

                minh = x0[d[t]], oldt=t;

                for (j=d[t]; t>=h && x0[x] < x0[d[t]]; --t ) {
                    if ( j-d[t] >= 2 && ( minh > x0[d[t-1]] || t==h ) ) {
                        if ( x0[d[t]] < minh ) minh = x0[d[t]];

                        ur[l1][++nu[l1]][0]=d[t],
                        ur[l1][nu[l1]][1]=j,
                        ur[l1][nu[l1]][2]=minh;
                    }
                    if ( x0[d[t]] < minh ) minh = x0[d[t]];
                }

                t = oldt;
                d[++t] = x;
            }
        }

        minh = x0[d[t]];

        for (j=d[t]; t>=h; --t ) {
        
            if ( j-d[t] >= 2 && ( minh > x0[d[t-1]] || t==h ) ) {
                if ( x0[d[t]] < minh ) minh = x0[d[t]];

                ur[l1][++nu[l1]][0]=d[t],
                ur[l1][nu[l1]][1]=j,
                ur[l1][nu[l1]][2]=minh;
            }

            if ( x0[d[t]] < minh ) minh = x0[d[t]];            
        }
    }

    memcpy(nl, nu, sizeof(nu));
    memcpy(lr, ur, sizeof(ur));
    nu[l1] = 0;
    
    memset(x0, 0, sizeof(x0));
    memset(nu, 0, sizeof(nu));

    for (l1=1; l1<n-1; ++l1)
    {
        h = 1, t = 0;
        nu[l1] = 0; // nu[l1]mber of up - rectangles

        for (x=1; x<=m; ++x) {
            if ( a[l1][x] ) {
                x0[x] = 0;

                minh = x0[d[t]];

                for (j=d[t]; t>=h; --t) {
                    if ( j-d[t] >= 2 && ( minh > x0[d[t-1]] || t==h ) )  {
                        if ( x0[d[t]] < minh ) minh = x0[d[t]];
                    
                        ur[l1][++nu[l1]][0] = d[t],
                        ur[l1][nu[l1]][1] = j,
                        ur[l1][nu[l1]][2] = minh;
                    }

                    if ( x0[d[t]] < minh ) minh = x0[d[t]];
                }

                h=1, t=0;
            }
            
            else {
                ++x0[x];

                minh = x0[d[t]], oldt = t;

                for (j=d[t]; t>=h && x0[x] < x0[d[t]]; --t ) {
                    if ( j-d[t] >= 2 && ( minh > x0[d[t-1]] || t==h ) ) {
                        if ( x0[d[t]] < minh ) minh = x0[d[t]];
                    
                        ur[l1][++nu[l1]][0]=d[t],
                        ur[l1][nu[l1]][1]=j,
                        ur[l1][nu[l1]][2]=minh;
                    }

                    if ( x0[d[t]] < minh ) minh = x0[d[t]];
                }

                d[++t] = x;
            }
        }

        minh = x0[d[t]];

        for (j=d[t]; t>=h; --t ) {
        
            if ( j-d[t] >= 2 && ( minh > x0[d[t-1]] || t==h ) ) {
                if ( x0[d[t]] < minh ) minh = x0[d[t]];
            
                ur[l1][++nu[l1]][0]=d[t],
                ur[l1][nu[l1]][1]=j,
                ur[l1][nu[l1]][2]=minh;
            }

            if ( x0[d[t]] < minh ) minh = x0[d[t]];
        }
    }

    // sort ur
int AUX;
# define    swp(x, y)   (AUX=x, x=y, y=AUX)

    for (i=1; i<=n; ++i) {
        for (j=1; j<nu[i]; ++j)
            for (k=j+1; k<=nu[i]; ++k)
                if ( (ur[i][j][0] > ur[i][k][0]) ||
                     (ur[i][j][0]== ur[i][k][0] && ur[i][j][1]>ur[i][k][1] ))
                    swp(ur[i][j][0], ur[i][k][0]),
                    swp(ur[i][j][1], ur[i][k][1]),
                    swp(ur[i][j][2], ur[i][k][2]);

        for (j=1; j<nl[i]; ++j)
            for (k=j+1; k<=nl[i]; ++k)
                if ( (lr[i][j][0] > lr[i][k][0]) ||
                     (lr[i][j][0]== lr[i][k][0] && lr[i][j][1]>lr[i][k][1] ))
                    swp(lr[i][j][0], lr[i][k][0]),
                    swp(lr[i][j][1], lr[i][k][1]),
                    swp(lr[i][j][2], lr[i][k][2]);
    }

    int st, dr, dist, auxa;
    int sst, ddr;
    int iu, il, ic; // i up, u low, i column
    int ju, jl, jc;

    for (l1=1; l1<n-1; ++l1) {

        for (l2=n; l2>l1; --l2) {
            if ( l2==l1+1 ) continue;

            dist = l2-l1-1;

            // see columns
            for (x=st=1, nc=0; x<=m; ++x)
                if ( n0(l1+1, x, l2-1, x) == dist ) ++dr;
                else {
                    if ( st != x )
                        c[ ++nc ][ 0 ] = st,
                        c[ nc ][ 1 ] = x-1;

                    st = x + 1;
                }

            if ( st <= m ) c[ ++nc ][ 0 ] = st, c[nc][1] = m;

            iu = il = ic = 1;


            for (; iu<=nu[l1] && il <= nl[l2] && ic <= nc; ++iu) {
            
                for (jc=ic; jc<=nc &&
                     c[jc][0] < ur[l1][iu][1]
                     ; ++jc) {
                          st = max(c[jc][0], ur[l1][iu][0]+1);
                          dr = min(c[jc][1], ur[l1][iu][1]-1);

                          if ( st>dr ) continue;

                        for (jl=il; jl<=nl[l2] &&
                             lr[l2][jl][0] < dr ; ++jl ) {
                                 sst = max(st, lr[l2][jl][0]+1);
                                 ddr = min(dr, lr[l2][jl][1]-1);

                                 if ( sst > ddr ) continue;

                                 auxa = (ur[l1][iu][1]-ur[l1][iu][0]+1) * ur[l1][iu][2] +
                                        (lr[l2][jl][1]-lr[l2][jl][0]+1) * lr[l2][jl][2] +
                                            (ddr-sst+1) * dist;

                                 if ( auxa > sol ) sol = auxa;
                             }
                    }

                for (;c[ic][1] <= ur[l1][iu][0] && ic <= nc; ++ic);
                for (;lr[l2][il][1] <= c[ic][0] && il <= nl[l2]; ++il);
            }
        }
    }

}

int main()
{
    readf();
    solve();

    freopen(_fout, "w", stdout);

    printf("%d\n", sol);

    return 0;
}
