#include <stdio.h>
#include <vector>
#include <algorithm>
using namespace std;

#define NMAX 3010
#define MP make_pair
#define MOD 666013

int N, M;

pair <int, int> a[NMAX];

vector <int> leg[NMAX];

int poz[NMAX];
int ipoz[NMAX];

int nr[NMAX];

short best[NMAX][NMAX];

inline int MIN(int a, int b) { return (a < b) ? a : b; }

char viz[NMAX];

int beg;
char s[1000];

inline void GET(int &x)
{
	x = 0;

	for (; s[beg] && !('0' <= s[beg] && s[beg] <= '9'); beg++);

	for (; s[beg] && '0' <= s[beg] && s[beg] <= '9'; beg++)
		x = x * 10 + s[beg] - '0';
}

/*
short bst[NMAX][NMAX];
#include <bitset>

bitset <NMAX> aj[NMAX];

void get_brute()
{
	int i;
	
	aj[N][N] = 1;

	for (i = N - 1; i >= 1; i--) {
		aj[i][i] = 1;

		for (vector <int> :: iterator it = leg[i].begin(); it != leg[i].end(); ++it) aj[i] |= aj[*it];
	}

	int j, k;

	for (i = 1; i <= N; i++)
		for (j = i + 1; j <= N; j++) {
			bst[j][i] = bst[ i ][ j ] = N + 1;
			for (k = j; k <= N; k++) 
				if (aj[i][k] == 1 && aj[j][k] == 1)
					if (k < bst[i][j]) 
						bst[j][i] = bst[i][j] = k;
		}
}

int gen(int N, int M)
{
	freopen("casute.in", "w", stdout);

	printf("%d %d\n", N, M);

	int i, q;
	for (i = 1; i <= N; i++) {
		q = rand() % N + 1;
		while (viz[q]) {
			q++;
			if (q == N + 1) q = 1;
		}
		viz[q] = 1;
		printf("%d ", q);
	}
	printf("\n");

	for (i = 1; i <= M; i++) printf("%d %d\n", rand() % N + 1, rand() % N + 1);

fclose(stdout);
return 0;
}
*/

int main()
{
//	srand(13);
//	gen(455, 3123);
//	memset(viz, 0, sizeof(viz));
	
	int i, q, x, y, j;
	
	freopen("casute.in", "r", stdin);
	freopen("casute.out", "w", stdout);

	scanf("%d %d\n", &N, &M);

	for (i = 1; i <= N; i++) {
		scanf("%d", &q);
//		GET(q);
		a[i] = MP(q, i);
	}
	scanf("\n");

	sort(a + 1, a + N + 1);

	for (i = 1; i <= N; i++) {
		poz[ a[i].second ] = i;
		ipoz[ i ] = a[i].second;
	}

	ipoz[N + 1] = N + 1;
	poz[N + 1] = N + 1;

	for (i = 1; i <= M; i++) {
//		scanf("%d %d", &x, &y);
		fgets(s, 1000, stdin);
		beg = 0;
		GET(x);
		GET(y);

		leg[ poz[x] ].push_back( poz[y] );
		leg[ poz[y] ].push_back( poz[x] );

		nr[ poz[x] ] ++;
		nr[ poz[y] ] ++;
	}

//	vector <int> :: iterator it;
	int jj;
	for (i = N; i >= 1; i--) {
		best[ i ][ i ] = i;

		for (j = i + 1; j <= N; j++) best[ i ][ j ] = N + 1;

		for (jj = 0; jj < nr[i]; jj++) {
			y = leg[i][jj];

			if (y < i) continue;

			for (j = i + 1; j <= y; j++) {
				q = best[ j ][ y ];

				if (q < best[ i ][ j ] )
					best[ i ][ j ] = q; 
			}

			for (; j <= N; j++) {
				q = best[ y ][ j ];

				if (q < best[ i ][ j ] )
					best[ i ][ j ] = q; 
			}
		}
	}

//	printf("da\n");

	for (i = 1; i <= N; i++) 
		for (j = i + 1; j <= N; j++) {
			if (best[i][j] == N + 1) best[i][j] = 0;
			best[j][i] = best[i][j];
		}

/*	get_brute();
	for (i = 1; i <= N; i++)
		for (j = 1; j <= N; j++) {
			if (bst[i][j] == N + 1) bst[i][j] = 0;
		}

	for (i = 1; i <= N; i++) 
		for (j = i + 1; j <= N; j++) {
//			printf("%d %d - %d %d\n", ipoz[i], ipoz[j], best[ipoz[i]][ipoz[j]], bst[ipoz[i]][ipoz[j]]);
			if (best[ipoz[i]][ipoz[j]] != bst[ipoz[i]][ipoz[j]]) printf("kkkkkkkkkkkkkkkkkk\n");
		}
	int rez1 = 0;
	for (i = 1; i <= N; i++) {
		for (j = i + 1; j <= N; j++) {
			rez1 = (rez1 * (N + 1) + poz[ bst[ poz[i] ][ poz[j] ] ]) % MOD;
		}
	}

	printf("%d\n", rez1);
*/
	int rez = 0, pi;
	for (i = 1; i <= N; i++) {
		pi = poz[i];
		for (j = i + 1; j <= N; j++) {
			rez = (rez * (N + 1) + poz[ best[ pi ][ poz[j] ] ]) % MOD;
		}
	}

	printf("%d\n", rez);

fclose(stdin);
fclose(stdout);
return 0;
}

