#include <cstdio>
#include <math.h>
#include <map>

using namespace std;

#define Dmax 2000
#define base 10

int n;
map<int, int> H1;
int v[Dmax];

void readdata()
{
   freopen("divizori.in", "r", stdin);
   freopen("divizori.out", "w", stdout);

   scanf("%d", &n);
   n -= 2;
}

void multiply(int k)
{
   int i, t = 0;

   for (i = 1; i <= v[0] || t; ++i)
   {
      v[i] = v[i]*k+t;
      t = v[i] / base;
      v[i] %= base;
   }
   v[0] = i-1;
}

void solve()
{
   int i, j, aux, cnt, lim;

   v[0] = v[1] = 1;

   for (i = n+1; i <= 2*n; ++i)
   {
      aux = i;
      lim = int( sqrt(aux) );
      for (j = 2; (aux > 1) && (j <= lim); ++j)
      {
          for (cnt = 0; aux % j == 0; aux /= j, ++cnt);
          if (cnt) H1[j] += cnt;
      }
      if (aux) ++H1[aux];
   }

   for (i = 2; i <= n+1; ++i)
   {
      aux = i;
      lim = int( sqrt(aux) );
      for (j = 2; (aux > 1) && (j <= lim); ++j)
      {
          for (cnt = 0; aux % j == 0; aux /= j, ++cnt);
          if (cnt) H1[j] -= cnt;
      }
      if (aux) --H1[aux];
   }

   for (map<int, int> :: iterator it = H1.begin(); it != H1.end(); ++it)
       for (i = 1; i <= it->second; ++i)
           multiply(it->first);
}

void writedata()
{
   int i;

   for (i = v[0]; i; --i)
       printf("%d", v[i]);
   printf("\n");
   
   printf("1 ");
   for (i = n+1; i; --i)
       printf("%d ", i);
   printf("\n");
}

int main()
{
   readdata();
   solve();
   writedata();
   return 0;
}
