# include   <stdio.h>
# include   <string.h>

# define    _fin    "naveta.in"
# define    _fout   "naveta.out"

# define    maxn    414
# define    bign    70


int         ct[maxn][44][bign];
char        isset[maxn][maxn];

int n, k, N, K;

inline void make_n(int v[], int n) { v[0]=1, v[1]=n; }

int i, t=0;

void add(int a[], int b[])       // a += b
{
    for (i=1, t=0; i<=a[0] || i<=b[0] || t; i++, t/=10)
        a[i] = ( t += (a[i]+b[i]) ) % 10;
    a[0] = i-1;
}

void div(int a[], int b)
{
    for (i=a[0]; i; --i, t%=b)
        a[i] = ( t = t * 10 + a[i] ) / b;

    for (; !a[a[0]] && a[0]>1; --a[0]);
}

void comb(int n, int k)
{
    if ( isset[n][k] ) return;

//    ct[n][k] = new int[ bign ];
//    memset(ct[n][k], 0, sizeof(int) * (bign) );
    isset[n][k] = 1;

    if ( !k ) make_n( ct[n][k], 1 );
    else if ( k==1 ) make_n( ct[n][k], n );
    else if ( n==0 ) return;
    else {
        comb(n-1, k);
        comb(n-1, k-1);

        add ( ct[n][k], ct[n-1][k] );
        add ( ct[n][k], ct[n-1][k-1] );
    }
}

int main()
{
    freopen(_fin, "r", stdin);
    freopen(_fout,"w", stdout);

    scanf("%d %d\n", &k, &n);
    ++n;

    N = n * k + 1, K = n;

    comb(N, K);
    div(ct[N][K], N);

    for (int i=ct[N][K][0]; i>=1; --i)
        printf("%d", ct[N][K][i]);
    printf("\n");

    return 0;
}
