#include <cstdio>
#define MAXCIFRE 100

struct NUMAR {int n; short int x[MAXCIFRE];};

int n,k;
NUMAR comb[2][505];

NUMAR suma(NUMAR a, NUMAR b)
  {
   NUMAR c;
   int i=0,in_minte=0;
   while(i<a.n && i<b.n)
        {
         c.x[i]=a.x[i]+b.x[i]+in_minte;
         in_minte=c.x[i]/10;
         c.x[i]%=10;
         i++;
        }
   while(i<a.n)
        {
         c.x[i]=a.x[i]+in_minte;
         in_minte=c.x[i]/10;
         c.x[i]%=10;
         i++;
        }
   while(i<b.n)
        {
         c.x[i]=b.x[i]+in_minte;
         in_minte=c.x[i]/10;
         c.x[i]%=10;
         i++;
        }        
   while(in_minte)
        {
         c.x[i]=in_minte%10;
         in_minte/=10;
         i++;
        }
   c.n=i;
   return c;
  }

NUMAR impart(NUMAR a, int f)
  {
   NUMAR b;
   int in_minte=0;
   for(int i=a.n-1;i>=0;i--)
      {
       in_minte=in_minte*10+a.x[i];
       b.x[i]=in_minte/f;
       in_minte%=f;
      }
   b.n=a.n;
   return b;
  }

NUMAR catalan(int n, int k)
  {
   return impart(comb[(k*n)&1][n],(k-1)*n+1);
  }

void write(NUMAR a)
  {
   while(a.x[a.n-1]==0 && a.n>1)
        a.n--;
   printf("%d",a.x[a.n-1]);
   for(int i=a.n-2;i>=0;i--)
      printf("%d",a.x[i]);
  }

void init(int n)
  {
   int i,j;
   for(i=0;i<=n;i++)
      {
       comb[i&1][0].n=1;
       comb[i&1][0].x[0]=1;
       for(j=1;j<i;j++)
          {
           comb[i&1][j]=suma(comb[(i+1)&1][j],comb[(i+1)&1][j-1]);
          }
       comb[i&1][i].n=1;
       comb[i&1][i].x[0]=1;
      }
  }


int main()
{
freopen("naveta.in","r",stdin);
freopen("naveta.out","w",stdout);

scanf("%d %d",&k,&n);
init(k*(n+1));
write(catalan(n+1,k));

return 0;
}
