type ref=^inr;
     inr=record ch,h:integer;
                lf,rt:ref
       end;
function max2(a,b:integer):integer;
begin if a>b then max2:=a else max2:=b end;
function min(p:ref):ref;
begin
 if p^.lf=nil then min:=p
  else min:=min(p^.lf)
end;
function hi(p:ref):integer;
begin
 if p<>nil then hi:=p^.h
  else hi:=-1;
end;
procedure rotright(var r:ref);
var temp:ref;
begin
 temp:=r^.lf;
 r^.lf:=temp^.rt;
 temp^.rt:=r;
 r^.h:=1+max2(hi(r^.lf),hi(r^.rt));
 temp^.h:=1+max2(hi(temp^.lf),hi(r));
 r:=temp;
end;
procedure rotleft(var r:ref);
var temp:ref;
begin
 temp:=r^.rt;
 r^.rt:=temp^.lf;
 temp^.lf:=r;
 r^.h:=1+max2(hi(r^.lf),hi(r^.rt));
 temp^.h:=1+max2(hi(temp^.rt),hi(r));
 r:=temp;
end;
procedure drotright(var r:ref);
begin
 rotleft(r^.lf);
 rotright(r)
end;
procedure drotleft(var r:ref);
begin
 rotright(r^.rt);
 rotleft(r)
end;
procedure insert(var r:ref; y:integer);
var a:integer;
begin
 if r=nil then
  begin new(r); r^.lf:=nil; r^.rt:=nil; r^.ch:=y; r^.h:=0; end
 else
  begin
   if y<r^.ch then
    begin
     insert(r^.lf,y);
     a:=hi(r^.lf)-hi(r^.rt);
     if a>=2 then
       if y<r^.lf^.ch then
         rotright(r)
        else
         drotright(r)
      else {nu s-au facut rotatii, deci se recalculeaza adincimea lui r}
       r^.h:=1+max2(hi(r^.lf),hi(r^.rt))
    end
   else
    if y>r^.ch then
     begin
     insert(r^.rt,y);
     a:=hi(r^.rt)-hi(r^.lf);
     if a>=2 then
       if y>r^.rt^.ch then
         rotleft(r)
        else
         drotleft(r)
      else {nu s-au facut rotatii, deci se recalculeaza adincimea lui r}
       r^.h:=1+max2(hi(r^.lf),hi(r^.rt))
    end
     else
      writeln('valoarea se afla deja in arbore');
  end
end;
procedure del(var r:ref;vl:integer);
var tmp:ref;
begin
 if r=nil then begin writeln('not in that tree'); exit end;
 if vl>r^.ch then
  begin del(r^.rt,vl);
        if hi(r^.lf)-hi(r^.rt)=2 then
          if hi(r^.lf^.lf)>hi(r^.lf^.rt) then
             rotright(r)
           else drotright(r)
         else r^.h := max2(hi(r^.lf),hi(r^.rt))+1;
         exit
   end;
  if vl<r^.ch then
   begin del(r^.lf,vl);
         if hi(r^.rt)-hi(r^.lf)=2 then
          if hi(r^.rt^.rt)>hi(r^.rt^.lf) then
            rotleft(r)
           else drotleft(r)
         else r^.h := max2(hi(r^.lf),hi(r^.rt))+1;
         exit
    end;
   if r^.lf=nil then
    begin  tmp:=r^.rt;
           dispose(r);
           r:=tmp;
           exit
    end;
   if r^.rt=nil then
    begin  tmp:=r^.lf;
           dispose(r);
           r:=tmp;
           exit
    end;
   tmp:=min(r^.rt);
   r^.ch := tmp^.ch;
   del(r^.rt,tmp^.ch);
   if hi(r^.lf)-hi(r^.rt)=2 then
     if hi(r^.lf^.lf)>hi(r^.lf^.rt) then
           rotright(r)
       else drotright(r)
    else r^.h := max2(hi(r^.lf),hi(r^.rt))+1;
end;
procedure inord(p:ref);
begin
 if p<>nil then begin
  inord(p^.lf);
  write(p^.ch,' ');
  inord(p^.rt);
  end
end;
procedure preord(p:ref);
begin
 if p<>nil then begin
  write(p^.ch,' ');
  preord(p^.lf);
  preord(p^.rt);
  end
end;

var root:ref;
    t:text;
    nnod,i,j:integer;
begin
 assign(t,'a.txt');
 reset(t);
 root:=nil;
 while not eof(t) do
  begin
   read(t,i);
   insert(root,i);
   inc(nnod);
  end;
 writeln('arborele in preordine:');
 preord(root);
 writeln;
 writeln('arborele in inordine:');
 inord(root);
 writeln;
 writeln('adincimea arborelui=',hi(root));
 readln;
 for j := 1 to nnod div 2 do
  del(root,2*j);
 writeln('arborele in preordine:');
 preord(root);
 writeln;
 writeln('arborele in inordine:');
 inord(root);
 writeln;
 writeln('adincimea arborelui=',hi(root));
 readln
end.
