# include <iostream.h>
# include <math.h>
struct nod{ int ch,h;
	    nod* lf,* rt;
	  };
typedef nod* pnod;
int max2(int a, int b) {return a>b?a:b;}
pnod min(pnod p)
 { if (p->lf==NULL) return p;
     else return min(p->lf);
 }
int hi(pnod p)
{if (p==NULL) return -1;
 else return p->h;
}

void rotright(pnod& r)
{pnod temp=r->lf;
 r->lf = temp->rt;
 temp->rt = r;
 r->h = max2(hi(r->lf), hi(r->rt))+1;
 temp->h = max2(hi(temp->lf), hi(r))+1;
 r = temp;
}

void rotleft(pnod& r)
{pnod temp=r->rt;
 r->rt = temp->lf;
 temp->lf = r;
 r->h = max2(hi(r->lf), hi(r->rt))+1;
 temp->h = max2(hi(temp->rt), hi(r))+1;
 r = temp;
}

void drotright(pnod &r)
{rotleft(r->lf);
 rotright(r);
}
void drotleft(pnod &r)
{rotright(r->rt);
 rotleft(r);
}

void insert(pnod& r, int y)
{int a;
 if (r==NULL)
  {r = new nod; r->h=0; r->ch=y; r->lf=r->rt=NULL;}
 else
 {
  if (y<r->ch)
   { insert(r->lf,y);
     a=hi(r->lf) - hi(r->rt);
     if (a>=2)
	if (y<r->lf->ch) rotright(r);
	   else drotright(r);
     else r->h = max2(hi(r->lf),hi(r->rt))+1;
   }
  if (y>r->ch)
   {insert(r->rt,y);
    a=hi(r->rt) - hi(r->lf);
    if (a>=2)
      if (y>r->rt->ch) rotleft(r);
	else drotleft(r);
     else r->h = max2(hi(r->lf),hi(r->rt))+1;
   }
   if (y==r->ch) cout<<"Allready in tree"<<endl;
 }
}
void inord(pnod p)
 {if (p)
   {inord(p->lf); cout<<p->ch<<' ';inord(p->rt);}
 }
void preord(pnod p)
 {if (p)
   {cout<<p->ch<<' '; preord(p->lf); preord(p->rt);}
 }
void del(pnod& r, int val)
{ if (r==NULL) {cout<<val<<" not in the tree"<<endl; return;}
  if (val>r->ch)
   {del(r->rt,val);
    if (hi(r->lf)-hi(r->rt)==2)
      if (hi(r->lf->lf)>=hi(r->lf->rt))
	     rotright(r);
	else
	   drotright(r);
     else r->h=max2(hi(r->lf),hi(r->rt))+1;
     return;
    }
   if(val<r->ch)
   {del(r->lf,val);
    if (hi(r->rt)-hi(r->lf)==2)
      if (hi(r->rt->rt)>=hi(r->rt->lf))
	     rotleft(r);
	else
	   drotleft(r);
     else r->h=max2(hi(r->lf),hi(r->rt))+1;
     return;
    }
   if (r->lf==NULL)             //==
    {pnod temp=r->rt;
     delete r;
     r=temp;
     return;
    }
   if (r->rt==NULL)
    {pnod temp=r->lf;
     delete r;
     r=temp;
     return;
    }
   pnod temp=min(r->rt);
   r->ch=temp->ch;
   del(r->rt,temp->ch);
   if (hi(r->lf)-hi(r->rt)==2)
      if (hi(r->lf->lf)>=hi(r->lf->rt))
	     rotright(r);
	else
	   drotright(r);
     else r->h=max2(hi(r->lf),hi(r->rt))+1;
    return;
}
pnod root=NULL;
void main()
{ cout<<endl<<"Begins"<<endl;
  for (int i=1;i<16;i++)
   insert(root,i);
  preord(root);
   cout<<endl;
    cout<<"hight="<<hi(root)<<endl;
  for (i=1;i<=8;i++)
       del(root,i);
  cout<<endl<<"After del"<<endl;
  preord(root);
  cout<<endl<<"hight="<<hi(root);
}