#include <stdio.h>
# define nmax 200
int mat[nmax+1][nmax+1], dgr[nmax+1], par[nmax+1], viz[nmax+1];
int ct1, ct2, n,m;
void reduce(int v, int p)
{  int *x;
   int q,i,j,k1,k2,v1;

   viz[v]=1;

   if (p==1)    //am intrat cand mai sunt 2 in graf (v si inca unul) si ambele au grad 0
   {		//le trec pe in partitii diferite
     for (i=1;i<=n;i++)
	if (viz[i]==0)
	 { viz[i]=1;
	   par[i]=1; ct1++;
	 }
     par[v]=2; ct2++;
     return;
   }


   x = new int[nmax+1];		//vector de vecini
   for (i=1;i<=n;i++)
     x[i]=0;

   for (j=1;j<=n;j++)		//scot nodul v din graf
     if (mat[v][j] == 1 && viz[j]==0)
       { mat[v][j] = 0;
	 dgr[j]--;
	 x[j] = 1;		//retin vecinii lui v
       }

   for (i=1;i<n;i++)		//scot muchiile dintre vecinii adiacenti ai lui v din graf
     for (j=i+1;j<=n;j++)
       if (x[i]==1 && x[j]==1)
	if (mat[i][j]==1)
	 { mat[i][j] = mat[j][i] = 0;
	   dgr[i]--;
	   dgr[j]--;
	 }
	else
	 { mat[i][j] = mat[j][i] = 1;  //bag muchiile dintre vecinii neadiacenti ai lui v
	   dgr[i]++;
	   dgr[j]++;
	 }

   v1=0;         		//caut un nod cu grad impar in ce o ramas
   for (i=1;i<=n;i++)
     if (viz[i]==0 && dgr[i]%2==1)
       { v1=i; break;}

   if (v1==0)	//nu e niciunul cu grad impar -> le trec pe toate intr-o partitie
    { for (i=1;i<=n;i++)
	if (viz[i]==0)
	  { par[i]=1; ct1++;}
    }
   else
     reduce(v1,p-1);

   // trec nodul v intr-una dinre partitii

   k1=k2=0;
   for (i=1;i<=n;i++)
     if (x[i]==1)
       if (par[i]==1)
	 k1++;
       else
	 k2++;
   if (k1%2 == 0)
     { par[v]=1; ct1++;}
   else
     { par[v]=2; ct2++;}

// delete [nmax+1]x;

}


int main()
{ int i,v1,v2,j;
  FILE * fi, *fo;
  printf("\n\n");
  fi = fopen("graf.in","rt");
  fo = fopen("graf.out","wt");
  fscanf(fi,"%d%d",&n,&m);
  for (i=1;i<=m;i++)
    { fscanf(fi,"%d%d",&v1,&v2);
      mat[v1][v2]=mat[v2][v1] = 1;
      dgr[v1]++; dgr[v2]++;
    }
/*  for (i=1;i<=n;i++)
    { for (j=1;j<=n;j++)
	printf("%d ",mat[i][j]);
      printf("\n");
    }
*/
  v1=0;
  for (i=1;i<=n;i++)
    if (dgr[i]%2==1)
      { v1 = i; break;}
  if (v1==0)
   { fprintf(fo,"%d 0\n",n);
     for (i=1;i<=n;i++)
       fprintf(fo,"%d ",i);
     fprintf(fo,"\n");
     return 0;
   }


  reduce(v1,n);

  fprintf(fo,"%d %d\n",ct1,ct2);
  for (i=1;i<=n;i++)
   if (par[i]==1)
    fprintf(fo,"%d ",i);
  fprintf(fo,"\n");
  for (i=1;i<=n;i++)
   if (par[i]==2)
    fprintf(fo,"%d ",i);
  fprintf(fo,"\n");
  fcloseall();
  return 0;
}


