#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <vector>
#include <algorithm>
using namespace std;

#define FOR(i, a, b)  for (i = (a); i <= (b); i ++)
#define REP(i, n)     for (i =   0; i <  (n); i ++)
#define FORD(i, a, b) for (i = (a); i >= (b); i --)
#define MP            make_pair
#define PB            push_back

#define NMAX 1024


int N, K, i, j, k, x, y, Ans, AnsX, AnsY, INF, A[NMAX][NMAX], M[NMAX][NMAX];
char F[NMAX][NMAX];
vector<pair<int, int> > D[2 * NMAX];
vector<pair<int, int> > :: iterator it;

void gen(void)
{
    freopen("centru.in", "w", stdout);
    N = 100, K = 50;
    memset(F, 0, sizeof(F));

    printf("%d %d\n", N, K);
    REP(k, K)
    {
        do { i = rand() % N, j = rand() % N; } while (F[i][j]);
        F[i][j] = 1;
        printf("%d %d\n", i, j);
    }
}

int main(void)
{
 //   gen(); return 0;
	freopen("centru.in", "r", stdin);
	freopen("centru.out", "w", stdout);
	scanf("%d %d", &N, &K);

	memset(F, 0, sizeof(F));
	for (k = 0; k < K; k ++)
	{
		if (scanf("%d %d", &i, &j) != 2)
		{
			fprintf(stderr, "n-am prea citit ce trebuia\n");
		}
		if (F[i][j] == 1)
		{
			fprintf(stderr, "duplicate entry\n");
		}
		F[i][j] = 1;
	}
	memset(M, 0x33, sizeof(M)), INF = M[0][0];
	
	// I
	memset(A, 0x33, sizeof(A));
	FOR(i, 0, N-1) FOR(j, 0, N-1)
	{
		if (F[i][j]) A[i][j] = -i-j;
		if (i > 0) A[i][j] <?= A[i-1][j];
		if (j > 0) A[i][j] <?= A[i][j-1];
		if (A[i][j] != INF && i+j+A[i][j] < M[i][j]) M[i][j] = i+j+A[i][j];
	}
	
	// II
	memset(A, 0x33, sizeof(A));
	FOR(i, 0, N-1) FORD(j, N-1, 0)
	{
		if (F[i][j]) A[i][j] = -i+j;
		if (i > 0) A[i][j] <?= A[i-1][j];
		if (j+1 < N) A[i][j] <?= A[i][j+1];
		if (A[i][j] != INF && i-j+A[i][j] < M[i][j]) M[i][j] = i-j+A[i][j];
	}
	
	// III
	memset(A, 0x33, sizeof(A));
	FORD(i, N-1, 0) FOR(j, 0, N-1)
	{
		if (F[i][j]) A[i][j] = i-j;
		if (i+1 < N) A[i][j] <?= A[i+1][j];
		if (j > 0) A[i][j] <?= A[i][j-1];
		if (A[i][j] != INF && -i+j+A[i][j] < M[i][j]) M[i][j] = -i+j+A[i][j];
	}

	// IV
	memset(A, 0x33, sizeof(A));
	FORD(i, N-1, 0) FORD(j, N-1, 0)
	{
		if (F[i][j]) A[i][j] = i+j;
		if (i+1 < N) A[i][j] <?= A[i+1][j];
		if (j+1 < N) A[i][j] <?= A[i][j+1];
		if (A[i][j] != INF && -i-j+A[i][j] < M[i][j]) M[i][j] = -i-j+A[i][j];
	}
	
/*
	REP(i, N)
	{
		REP(j, N) printf(F[i][j] ? "X" : ".");
		printf("\n");
	}
	printf("\n");
	
	REP(i, N)
	{
		REP(j, N) printf("%2d ", M[i][j]);
		printf("\n");
	}
*/
	
	int mins = INF, maxs = -INF, mind = INF, maxd = -INF;
	Ans = INF;
	
	REP(i, N) REP(j, N) D[M[i][j]].PB(MP(i, j));
	FORD(k, 2*N-1, 0)
	{
		for (it = D[k].begin(); it != D[k].end(); it ++)
		{
			mins <?= it->first + it->second;
			maxs >?= it->first + it->second;
			mind <?= it->first - it->second;
			maxd >?= it->first - it->second;
		
		}
        
        if (maxs-mins == maxd-mind)
        {
            if ((maxs&1)==(maxd&1) && (maxs&1)==(mind&1))
            {
                if (max(maxs-mins, maxd-mind) <= 2*(k-1))
                    Ans = k-1;
            }
            else
            {
                if (max(maxs-mins, maxd-mind)+1 <= 2*(k-1))
                    Ans = k-1;
            }
		}
        else
        {
            if (maxs-mins > maxd-mind)
            {
                if (maxs-mins > maxd-mind+1)
                {
                    if (maxs-mins <= 2*(k-1)) Ans = k-1;
                }
                else
                {
                    if ((maxd-mind)&1)
                    {
                        if (maxs-mins+1 <= 2*(k-1)) Ans = k-1;
                    }
                    else
                    {
                        if (maxs-mins <= 2*(k-1)) Ans = k-1;
                    }
                }
            }
            else
            {
                if (maxd-mind > maxs-mins+1)
                {
                    if (maxd-mind <= 2*(k-1)) Ans = k-1;
                }
                else
                {
                    if ((maxs-mins)&1)
                    {
                        if (maxd-mind+1 <= 2*(k-1)) Ans = k-1;
                    }
                    else
                    {
                        if (maxd-mind <= 2*(k-1)) Ans = k-1;
                    }
                }
            }
            
        }
	}

	printf("%d\n", Ans);
	return 0;
}
