/* Solutie O(N*M) */
#include <stdio.h>
#include <algorithm>
#include <vector>

using namespace std;

#define MAX_N 3005
#define MOD 666013
#define FIN "casute.in"
#define FOUT "casute.out"
#define pb push_back

int N, M, H[MAX_N], P[MAX_N], in[MAX_N], Q[MAX_N], Res; 
vector<int> G[MAX_N]; char reach[MAX_N]; short lca[MAX_N][MAX_N];

void DFS(int src, int n)
{
    vector<int>::iterator it;

    reach[n] = 1; 
    lca[src][n] = lca[n][src] = src;
    for (it = G[n].begin(); it != G[n].end(); it++)
        if (!reach[*it]) DFS(src, *it);
}

int main(void)
{
    int i, j, n, ql, qr;
    vector<int>::iterator it;

    freopen(FIN, "r", stdin);
    freopen(FOUT, "w", stdout);

    scanf("%d %d", &N, &M);
    H[0] = 0x3f3f3f3f;
    for (i = 1; i <= N; i++) scanf("%d", H+i);
    for (; M; M--)
    {
        scanf("%d %d", &i, &j);
        G[j].pb(i); in[i]++;
    }

    for (i = 1; i <= N; i++) 
    {
        memset(reach, 0, sizeof(reach));
        DFS(i, i);
    }

    ql = 0, qr = -1;
    for (i = 1; i <= N; i++) if (!in[i]) Q[++qr] = i;
    for (; ql <= qr; ql++)
        for (it = G[n = Q[ql]].begin(); it != G[n].end(); it++)
        {
            for (i = 1; i <= N; i++)
                if (H[lca[n][i]] < H[lca[*it][i]]) 
                    lca[*it][i] = lca[i][*it] = lca[n][i];
            if (--in[*it] == 0) Q[++qr] = *it;
        }

    for (i = 1; i <= N; i++)
        for (j = i+1; j <= N; j++)
            Res = (Res*(N+1) + lca[i][j]) % MOD;
    printf("%d\n", Res);

    return 0;
}
