#include <iostream>
#include <vector>
#include <iterator>
using namespace std;

// clasa de functori
template <class T>
struct Pred {
	bool operator()(T x, T y) const
	{
    	return x < y;
	}
};

template <class T>
struct Print {
	void operator() (T val)
	{
		cout << val << " ";
	}
};

int main()
{
    int a[] = { 40, 20, 10, 30 };
    vector<int> v(a, a + 4);  // vector<int>(it1, it2);
    Print<int> f1;
	for_each(v.begin(), v.end(), f1 );
 	cout << '\n';
 	Pred<int> f2;
	sort(v.begin(), v.end(), f2 );

	
	copy(v.begin(), v.end(), ostream_iterator<int>(cout, " "));
	
	system("pause");
    return 0;
}


