// prototipurile template ala containerelor standard

template <class T, class Alloc = allocator<T> >
	class vector;

template <class T, class Cont = vector<T>, class Comp = less<T> >
	class priority_queue;

template <class Key, class Compare = less<Key>, class Alloc = allocator<Key> >
	class multiset;

template <class Key, class T, class Compare = less<Key>, Alloc = allocator<pair<const Key, T> > >
	class map;
	


priority_queue<int, vector<int>, Comp > Q;
multiset<int, Compare> S;

typedef int eticheta;
typedef int distanta;
map<eticheta, distanta, Comp> M;

