#include <iostream>
#include <list>
#include <cassert>
using namespace std;

typedef list<char> LC;
typedef LC::iterator ITC;

void Afiseaza(LC L)
{
	for ( ITC it = L.begin(); it != L.end(); ++it )
		cout << *it;
	cout << '\n';
}

int main()
{
	char a[] = "ABC";
	// declar o lista x, cu elementele preluate din a[]
	LC x(a, a + 3);  
	LC L;                   // declar o lista vida
	
	// muta secventa controlata de x, in L
	L.splice(L.begin(), x); // *
	assert(x.empty());
	Afiseaza(L);            // ABC

	// muta primul caracter din L
    // inainte de sfarsit in x
	x.splice(x.end(), L, L.begin()); 
	Afiseaza(x);            // A
	Afiseaza(L);            // BC
	
	// muta intervalul [L.begin(), L.end())
	// la inceputul lui x
	x.splice(x.begin(), L, L.begin(), L.end());
	Afiseaza(x);            // BCA
	assert(L.empty());

 	cout << "Testare cu succes!";
	system("pause");
	return 0;
}

