// Coada cu prioritati
#include <iostream>
#include <queue>
#include <iterator>
using namespace std;

int main()
{
    priority_queue<int> q;  //, greater<int>                                                                             

    q.push(10);                  // O(log n)
    q.push(15);
    q.push(1);
    q.push(110);
    q.push(-8);
    q.push(50);
    
    cout << q.size() << '\n';    // O(1)   
    
    while ( ! q.empty() )        // O(1)   
    {
        cout << q.top() << " ";  // O(1)   - operatie in timp constant 
        q.pop();                 // O( log(n) )
    }   
    
    system("pause");
    return 0;
}



