// Continere (containment, layering, composition)

template <typename T1>
class A {
	T1 a;
public:
	A();
	A(T1 x);
};

template <typename T1, typename T2>
class B {
	T1 b;
	A<T2> a;
public:
	B();
	B(T1 y, T2 x);
};

template <typename T1>
A<T1>::A(T1 x) : a(x)
{
}

template <typename T1, typename T2>
B<T1, T2>::B(T1 y, T2 x) : b(y) , a(x)
{
}

int main()
{
	B<int, char> ob1(10, 'A');
	return 0;
}





