// Clase Template
// Functii membre definite in exteriorul clasei

#include <iostream>
using namespace std;

template <class T>
class A {
    T a;
public:
    A<T>();
    A<T>(T b);
    T Get() const;
};

template <class T>
A<T>::A<T>() {}

template <typename T>
A<T>::A<T>(T b)
{
    a = b;
}

template <typename T>
T A<T>::Get() const                
{
    return a;
}    

int main()
{
    A<float> *p;      // nu se creaza o clasa pe baza sablonului
    
    p = new A<float> [100];  // ACUM se genereaza o clasa  !
    A<int> o1(100);           // instantiaza o noua clasa A<int> [specializare] pe baza sablonului 
    cout << o1.Get() << "\n";
    
    A<char> o2('E');
    cout << o2.Get() << "\n";
    A<const char*> o3("PANTA REI"); 
    cout << o3.Get() << "\n";
    system("pause");
}
   


    
