// Clase Template

#include <iostream>
using namespace std;

template <typename T1, typename T2> 
class A {
    T1 a;
    T2 b;
public:
    A() {}
    A(T1 n = 0, T2 m = 0) : a(n), b(m) {}
    T1 Get() const { return a; }
};

int main()
{
    A<int, int> o1(100, 45);           // instantiaza o noua clasa A<int> [specializare] pe baza sablonului 
    cout << o1.Get() << "\n";
    
    A<char, double> o2('E', 6.423);
    cout << o2.Get() << "\n";
    int sir[] = { 2, 4, 6, 7 };
    A<const char*, const int*> o3("PANTA REI", sir); 
    cout << o3.Get() << "\n";
    system("pause");
}
   


    
