#include <iostream>
#include <cmath>
using namespace std;
/*
template <typename T>
class Complex {
	T re, im;
public:
	Complex(T r, T i) : re(r), im(i) {}   // constructor
	Complex(const Complex& c)             // constructor de copie
		: re(c.r), im(c.i) {}
   ~Complex() {}                          // destructor
    Complex& operator= (const Complex& c) // operator de atribuire
    {
		re = c.re; im = c.im;
	};
	T Modul() const                       // functie membra
	{
		return sqrt(re * re + im * im);
	}
};
*/


template <typename T>
class Complex {
	T re, im;
public:
	Complex<T>(T r, T i)
		: re(r), im(i) {}               // constructor
	Complex<T>(const Complex<T>& c)
		: re(c.r), im(c.i) {}           // constructor de copie
   ~Complex<T>() {}                     // destructor
    Complex<T>& operator= (const Complex<T>& c)
    { re = c.re; im = c.im; };          // operator de atribuire
	T Modul() const
	{ return sqrt(re * re + im * im); } // functie membra
};


int main()
{
	Complex<float> c(2.3, 4.5);
	cout << c.Modul();
}
