#include <iostream>
using namespace std;

template <typename T1, typename T2>
class A {
	T1 a;
	T2 b;
public:
	A();
	A(T1, T2);
	A(const A&);
    A& operator = (const A&);
    void Afis() const;
};

template <class T1, class T2>
A<T1, T2>::A(T1 x, T2 y) : a(x), b(y)
{
}

template <class T1, class T2>
A<T1, T2>::A()
{
}

template <class T1, class T2>
void A<T1, T2>::Afis() const
{
	cout << a << " " << b << endl;
}

template <class T1, class T2>
A<T1, T2>::A(const A<T1, T2>& ob)
{
    *this = ob;  // operatorul = definit in clasa
    cout << "Copiere\n";
}

template <class T1, typename T2>
A<T1, T2>& A<T1, T2>::operator = (const A<T1, T2>& ob)
{
    a = ob.a;
    b = ob.b;
    cout << "Atribuire\n";
}

int main()
{
	typedef A<const char*, const char*> SPEC;  // defineste o specializare
	SPEC a("Noaptea ", "vampirilor"), x("I", "Robot");
	a.Afis();
	SPEC ob(x);
	ob.Afis();
	ob = a;

	A<double, char> b(54.45, 'H');
	b.Afis();

	typedef A<const char*, int> Elev;  // o noua specializare
	Elev eu("Georgica", 16);
	eu.Afis();

}


