#include <iostream>
#include <cstring>
#include <iomanip>
using namespace std;

template <typename T1, typename T2>
void Read(T1 a[], T2 &n)
{
	cin >> n;
	for ( int i = 0; i < n; cin >> a[i++] );
}

template<>
void Read(char a[], int &n) // specializare pentru T1 = char T2 = int
{
	cin >> a; n = strlen(a);
}

template <typename T1, typename T2>
void Write(T1 a[], T2 n)
{
	for ( int i = 0; i < n; cout <<  a[i++] << " " );
}

void Write(double a[], int n) // supraincarcare
{
    for ( int i = 0; i < n; i++ )
    	cout << fixed << setprecision(2) << a[i] << " ";
}

template <>   // specializare pentru T1 = char T2 = int
void Write(char a[], int n)
{
    cout << a;
}

template <typename T> // supraincarcare cu alt template
void Write(T s)
{
    cout << "Salut " << s;
}

int main()
{
	int a[100], n;
    char s[100];

	Read(a, n);
	Write(a, n);

	Read(s, n);
	Write(s, n);
    Write(s);

	double d[100];
	Read(d, n);
	Write(d, n);
	system("pause");2
}
