// specializare functii
#include <iostream>
using namespace std;

template <typename T1, typename T2 >
void Read(T1 a[], T2 &n)
{
	cin >> n;
	for ( int i = 0; i < n; cin >> a[i++] );
}

template<> 
void Read(char a[], int &n)   // specializare cu T1 == char T2 == int
{
	cin >> a;
	n = strlen(a);
}

template <typename T1, typename T2>
void Write(T1 a[], T2 n)
{
	for ( int i = 0; i < n; cout <<  a[i++] << " " );
}

template <>
void Write(char a[])
{
    cout << a;
}

int main()
{
	int a[100], n;
    char s[100];
	Read(a, n);
	Write(a, n);
	
	Read(s, n);
	Write(s);
	cout << n;
	system("pause");
}

