#include <fstream>
using namespace std;

template <class T>
void Read(T a[], int &n, const char*);

template <class T>
void Write(T a[], int n, const char*);

template <class T>
void Sort(T a[], int n);

int main()
{
	int a[100], n;
	double b[100];

	Read(a, n, "sir.in");
	Sort(a, n);
	Write(a, n, "sir.out");

	return 0;
}

template <class T>
void Read(T a[], int &n, const char *s)
{
	ifstream fin(s);
	fin >> n;
	for ( int i = 0; i < n; i++ )
		fin >> a[i];
	fin.close();
}

template <class T>
void Write(T a[], int n, const char* s)
{
	ofstream fout(s);
	for ( int i = 0; i < n; i++ )
		fout << a[i] << " ";
	fout.close();
}

template <class T>
void Sort(T a[], int n)
{
	for ( int i = 0; i < n - 1; i++ )
		for ( int j = i + 1; j < n; j++ )
			if ( a[j] < a[i] )
			{
				T temp = a[i];
				a[i] = a[j];
				a[j] = temp;
			}

}
