#include <stdio.h>

#define inf (int)1e9
#define nmax 1005

typedef short int si;

int vx[] = {0,0,1,-1};
int vy[] = {1,-1,0,0};

int sol,maxim_de_cola = 0,N,a[nmax][nmax],n,k,i,j,p1,p2,px,py,q,p,maxl[2 * nmax],maxc[2 * nmax];
int sl[2 * nmax],sc[2 * nmax],jl[2 * nmax],jc[2 * nmax];
si sx[nmax * nmax],sy[nmax * nmax],col[nmax][nmax],lin[nmax][nmax];

inline int bun1(int x,int y) {
	if(x < 0 || x >= n || y < 0 || y >= n) return 0;
	return 1;
}

inline int max(int a,int b) {
	if(a > b) return a;
	else return b;
}

inline int bun(int x,int y) {
	if(x < 0 || x >= n || y < 0 || y >= n) return 0;
	if(a[x][y] == -1) return 1;
	return 0;
}

void bfs() {
	int i,nx,ny,q = 1;
	while(q <= p) {
		for(i = 0; i < 4; i++) {
			nx = sx[q] + vx[i]; ny = sy[q] + vy[i];
			if(bun(nx,ny)) {
				a[nx][ny] = a[sx[q]][sy[q]] + 1;
				maxim_de_cola = max(maxim_de_cola,a[nx][ny]);
				p++; sx[p] = nx; sy[p] = ny;
			}
		}
		q++;
	}
}

int bun(int x) {	
	int X = x + 1,crt;
	for(int i = 0; i < n; i++)
		for(int j = 0; j < n; j++) {
			crt = 0;
			crt = max(crt,lin[i][j] + X < 2 * n ? sl[lin[i][j] + X] : 0);
			crt = max(crt,lin[i][j] - X >= 0 ? jl[lin[i][j] - X] : 0);
			crt = max(crt,col[i][j] + X < 2 * n ? sc[col[i][j] + X] : 0);
			crt = max(crt,col[i][j] - X >= 0 ? jc[col[i][j] - X] : 0);
			if(crt <= x) return 1;
		}
	return 0;
}

int cauta(int x,int y) {
	int rez = y,mi = 0;
	while(x <= y) {
		mi = (x + y) / 2;
		if(bun(mi)) {
			rez = mi;
			y = mi - 1;
		}
		else x = mi + 1;
	}
	return rez;
}

int main() {
	freopen("centru.in","r",stdin);
	freopen("centru.out","w",stdout);

	scanf("%d%d",&n,&k);
	for(i = 0; i < n; i++)
		for(j = 0; j < n; j++) a[i][j] = -1;

	for(i = 1; i <= k; i++) {
		scanf("%d%d",&p2,&p1);
		a[p1][p2] = 0;
		p++; sx[p] = p1; sy[p] = p2;
	}

	bfs();

	N = n - 1;
	for(i = N; i >= -N; i--) {
		maxl[i + N] = 0;
		for(j = 0; j <= N; j++) 
			if(bun1(i + j,j)) {
				maxl[i + N] = max(maxl[i + N],a[i + j][j]);
				lin[i + j][j] = i + N;
			}
	}
	
	for(j = N; j >= -N; j--) {
		maxc[j + N] = 0;
		for(i = N; i >= 0; i--)
			if(bun1(i,i + j)) {
				maxc[j + N] = max(maxc[j + N],a[N - i][i + j]);
				col[N - i][i + j] = j + N;
			}
	}

	for(i = 2 * N; i >= 0; i--) sl[i] = max(sl[i + 1],maxl[i]);
	for(i = 0; i <= 2 * N; i++) jl[i] = max(i - 1 >= 0 ? jl[i - 1] : 0,maxl[i]);

	for(i = 2 * N; i >= 0; i--) sc[i] = max(sc[i + 1],maxc[i]);
	for(i = 0; i <= 2 * N; i++) jc[i] = max(i - 1 >= 0 ? jc[i - 1] : 0,maxc[i]);

	sol = cauta(0,maxim_de_cola);
	printf("%d\n",sol);

	return 0;
}
