#include <stdio.h>
#define KMAX 1000002

int x[KMAX], y[KMAX];
int px, py;
int min = 2000000000;
int n, k;

inline int MIN(int a, int b) { return (a < b) ? a : b; };
inline int MAX(int a, int b) { return (a > b) ? a : b; };
inline int ABS(int a) { return (a > 0) ? a : -a; }

int min_dist(int px, int py)
{
   int i, min = 2000000000, aux;
   for(i = 1; i <= k; ++i)
         if((aux = ABS(px-x[i]) + ABS(py-y[i])) < min)
                 min = aux;
   return min;
}
int max_dist(int px, int py)
{
   int i, max = -1, aux;
   for(i = 1; i <= k; ++i)
         if((aux = ABS(px-x[i]) + ABS(py-y[i])) > max)
                 max = aux;
   return max;
}

void read()
{
   int i;
   scanf("%d %d", &n, &k);
   for(i = 1; i <= k; ++i)
         scanf("%d %d", &x[i], &y[i]), px += x[i], py += y[i];
   px /= n;
   py /= n;
   if(px >= n)
         px = n-1;
   if(py >= n)
         py = n-1;
   min = max_dist(px, py);
}

void search()
{
   int search = 205, aux, count = 0;

   while(search)
   {
      if(search == 3)
                search = 2;
   
      if(px+search < n && (aux = max_dist(px+search, py)) < min)
           px += search, min = aux;
      else if(px-search > -1 && (aux = max_dist(px-search, py)) < min)
           px -= search, min = aux;
      else if(py+search < n && (aux = max_dist(px, py+search)) < min)
           py += search, min = aux;
      else if(py-search > -1 && (aux = max_dist(px, py-search)) < min)
           py -= search, min = aux;
      else if(px+search < n && py+search < n && (aux = max_dist(px+search, py+search)) < min)
           px += search, py += search, min = aux;
      else if(px-search > -1 && py+search < n && (aux = max_dist(px-search, py+search)) < min)
           px -= search, py += search, min = aux;
      else if(px+search < n && py-search > -1 && (aux = max_dist(px+search, py-search)) < min)
           px += search, py -= search, min = aux;
      else if(px-search > -1 && py - search > -1  && (aux = max_dist(px-search, py-search)) < min)
           px -= search, py -= search, min = aux;
      else
          search /= 2;

   }
}

int main()
{
   int i, j, aux;
   freopen("centru.in", "r", stdin);
   freopen("centru.out", "w", stdout);

   read();

   search();

  /*( for(i = 0; i <= 4; ++i)
         for(j = 0; j <= 4; ++j)
         {
               if(px-i > 0 && py-j > 0 && (aux = max_dist(px-i, py-j)) < min)
                    px -=i, py -=j, min = aux;
               else if(px+i < n && py - j > 0 && (aux = max_dist(px+i, py-j)) < min)
                    px += i, py -

  */

   printf("%d\n", min_dist(px, py));
   //printf("%d %d\n", px, py);
   
   fclose(stdin);
   fclose(stdout);
   return 0;
}














