#include <stdio.h>
#include <set>

using namespace std;

#define ll long long
#define MMax 7005

set<int> A[MMax];

int t0, t1, a, b, x, y, z, M;
ll N;

int sqr(int x)
{ return x * x; }

int gasit(int u, int v) // am gasit (u, v)
{ return A[u].find(v) != A[u].end(); }

int main(void)
{
    int i, poz, nxt, p, r, ok, u, v;
    
    freopen("sir.in", "r", stdin);
    freopen("sir.out", "w", stdout);

    scanf("%d %d %d %d %d %d %d %d %lld", &t0, &t1, &a, &b, &x, &y, &z, &M, &N);
    t0 %= M; t1 %= M;
    u = t0; v = t1;

    for (poz = 0; poz < N-1 && !gasit(t0, t1); poz++)
    {
        A[t0].insert(t1);
        
        nxt = (a * sqr(t0)) % M + (b * sqr(t1)) % M + x * t0 + y * t1 + z;
        nxt %= M;

        t0 = t1; t1 = nxt;
    }

    if (poz == N-1)
        printf("%d\n", t1);
    else
    {    
        r = -1; p = -1;
        
        for (poz = 0; p == -1; poz++)
        {
            if (t0 == u && t1 == v)
            {
                if (r == -1) r = poz;
                else { p = poz-r; break; }
            }
            
            nxt = (a * sqr(u)) % M + (b * sqr(v)) % M + x * u + y * v + z;
            nxt %= M;

            u = v; v = nxt;
        }

        N = (N-r) % p;

        if (N == 0) printf("%d\n", t0);
        else if (N == 1) printf("%d\n", t1);
        else
        {
            for (poz = 1; poz <= N-1; poz++)
            {
                nxt = (a * sqr(t0)) % M + (b * sqr(t1)) % M + x * t0 + y * t1 + z;
                nxt %= M;

                t0 = t1; t1 = nxt;
            }

            printf("%d\n", t1);        
        }

    }

    return 0;
}
