# include <stdio.h>
# include <string.h>
# include <time.h>
//# include <stdlib.h>

# define  _fin  "centru.in"
# define  _fout "centru.out"

# define  maxn  1001
# define  maxk  1000003

# define  nmax  1162261467 // 1000000000

# define  myint long long

# define  end_me    0.796


int d[maxn][maxn], n, k;
myint   cs[maxn], ls[maxn], ts;

int st = clock();

short int c[maxk][2];

int thepow;
int i, j, poz;

char buf[32];

void readf()
{
    //freopen(_fin, "r", stdin);
    FILE *fin = fopen(_fin, "r");

    fscanf(fin, "%d%d\n", &n, &k);

    for (i=1; i<=k; ++i) {
        fgets(buf, 32, fin);
# define    isd(x)  (x>=0x30 && x<=0x39)

        for (poz=0; isd(buf[poz]); ++poz) c[i][0] = c[i][0] * 10 + buf[poz] - 0x30;
        for (; buf[poz]==' '; ++poz);
        for (; isd(buf[poz]); ++poz) c[i][1] = c[i][1] * 10 + buf[poz] - 0x30;
    }
}

short int q[maxk][2], xx, yy, x, y;
int h, t;

const int dx[] = {-1,+1, 0, 0},
          dy[] = { 0, 0,-1,+1};

# define    ison(x) (x>=0 && x<n)

int getmax()
{
    memset(d, 0xff, sizeof(d));
    int max = 0;

    for (i=h=1, t=0; i<=k; ++i) {
        d[c[i][0]][c[i][1]] = 0,
        q[++t][0]=c[i][0], q[t][1]=c[i][1];
    }

    for (; h<=t; ++h)
        for (xx=q[h][0], yy=q[h][1], i=0; i<4; ++i) {
            x = xx + dx[i], y = yy + dy[i];
            if ( ison(x) && ison(y) )
                if ( d[x][y] == -1 ) {
                    d[x][y] = d[xx][yy] + 1,
                    q[++t][0] = x, q[t][1] = y;
                    if ( d[x][y] > max ) max = d[x][y];
                }
        }

    return max;
}

int exp(int x, int e)   // x ^ e
{
    int ret = 1, cr = x;

    while ( e ) {
        if ( e & 1 ) ret *= cr;
        cr *= cr;
        e >>= 1;
    }

    return ret;
}

int bests;

void solve()
{
    int max1 = getmax(), aux = nmax;

    if ( max1 > 1 )
    while ( aux >= max1 ) {
        ++thepow;
        aux /= max1;
    }
    else thepow = 0;

    long double cx=0, cy=0;

    for (i=0; i<n; ++i)
        for (j=0; j<n; ++j)
            d[i][j] = exp(d[i][j], thepow),
            cs[j] += d[i][j], ls[i] += d[i][j], ts += d[i][j];

    for (i=0; i<n; ++i)
        cx += ( (long double)(ls[i]*(i+1)) / (long double)(ts) ),
        cy += ( (long double)(cs[i]*(i+1)) / (long double)(ts) );

    bests = max1;

    --cx, --cy;
    
    c[++k][0] = (short int)cx, c[k][1] = (short int)cy;
    aux=getmax();
    if ( aux < bests ) bests = aux;

    if ( (double)(clock() - st) / CLOCKS_PER_SEC >= end_me ) return;

    c[k][0] = (short int)cx+1, c[k][1] = (short int)cy;
    aux=getmax();
    if ( aux < bests ) bests = aux;

    if ( (double)(clock() - st) / CLOCKS_PER_SEC >= end_me ) return;

    c[k][0] = (short int)cx, c[k][1] = (short int)cy+1;
    aux=getmax();
    if ( aux < bests ) bests = aux;

    if ( (double)(clock() - st) / CLOCKS_PER_SEC >= end_me ) return;

    c[k][0] = (short int)cx+1, c[k][1] = (short int)cy+1;
    aux=getmax();
    if ( aux < bests ) bests = aux;
}

int main()
{
    readf();
    solve();

    freopen(_fout, "w", stdout);

    printf("%d\n", bests);

    return 0;
}
