# include <stdio.h>

# define  maxn  100001


//typedef struct nod {
//    int x;  // valoare
//    nod *st, *dr, *p;
//}   *pnod;

//pnod    h;          // heap
//pnod    l[maxn];    // adresa catre o linie

int     h[maxn], a[maxn];   // max-heap
int     n, m, ns, dx[maxn];

// h[x] = linia care se afla pe acea pozitie in heap
// a[x] = unde se afla o linie in heap

void readf()
{
//    freopen("nakhla.in", "r", stdin);
//    FILE *fin = fopen("nakhla.in", "r");

//    fscanf(fin, "%d%d", &n, &m);
    scanf("%d%d", &n, &m);

    for (int i=1, x, y; i<=n; ++i) {
//        fscanf(fin, "%d%d", &x, &y);
        scanf("%d%d", &x, &y);
        dx[i] = y-x-1, ns ^= dx[i];
    }
}

# define    st(x)   ((x)<<1)
# define    dr(x)   (((x)<<1)|1)
# define    pr(x)   ((x)>>1)

void reheap(int i)
{
    int max=i;
    
    while ( 1 ) {
        max = i;
        if ( st(i) <= h[0] && dx[ h[st(i)] ] > dx[ h[max] ] ) max = st(i);
        if ( dr(i) <= h[0] && dx[ h[dr(i)] ] > dx[ h[max] ] ) max = dr(i);

        if ( max==i ) return;

        h[i] ^= h[max] ^= h[i] ^= h[max];
        a[h[i]] = i, a[h[max]] = max;

        i = max;
    }
}

// FILE *fout = fopen("test.out", "w");

/*void writeon(int left)
{
    int i;

    for (i=1; i<=n; ++i)
        fprintf(fout, "%d ", dx[h[i]]);
    fprintf(fout, "left = %d\n", left);
}*/

void solve()
{
    int i, left=n, nsp, move, line, x, y;

    for (h[0]=n, i=1; i<=n; ++i) {
        h[i] = i, a[i] = i;
        left -= ( !dx[i] );
    }

    for (i=pr(n); i>=1; --i)
        reheap(i);

    while ( left ) {
        for (i=1; i<=h[0]; ++i) {
            nsp = ns ^ dx[ h[i] ];  // ns prim
            move = dx[ h[i] ] - nsp;

            if ( move > 0 ) {
                dx[ h[i] ] -= move;

                printf("%d %d\n", h[i], move);
                fflush(stdout);

                if ( !dx[ h[i] ] ) --left;
                if ( !left ) return;

                reheap(i);
                ns = 0;

                scanf("%d%d", &x, &y);

                ns ^= dx[x];

                dx[x] -= y;

                ns ^= dx[x];
                
                if ( !dx[x] ) --left;
                if ( !left ) return;
                
                reheap( a[x] );

//                writeon(left);

                break;
            }
        }
    }
}

int main()
{
    readf();
    solve();

    return 0;
}
