#include <stdio.h>
#include <bitset>
using namespace std;

#define NMAX 100010

int N, M;

int a[NMAX];

bitset <NMAX << 2> aint[35];

void update(int a, int x, int y, int q, int nod, int val)
{
	if (x == y) {
		aint[a][q] = val;
		return;
	}

	int mij = (x + y) >> 1;

	if (nod <= mij) update(a, x, mij, q << 1, nod, val);
	else update(a, mij + 1, y, (q << 1) + 1, nod, val);

	aint[a][q] = aint[a][q << 1] == 1 || aint[a][(q << 1) + 1] == 1;
}

int get_nr(int a, int x, int y, int q)
{
	if (x == y) return x;

	int mij = (x + y) >> 1;

	if (aint[a][q << 1] == 1) return get_nr(a, x, mij, q << 1);
	return get_nr(a, mij + 1, y, (q << 1) + 1);
}

inline void baga(int nr, int val)
{
	int j, k;

	for (j = 1, k = 0; j <= a[nr] && j > 0; j <<= 1, k++)
		if (j & a[nr]) update(k, 1, N, 1, nr, val);
}

int main()
{
	int i, aa, bb, j, k;
	
	scanf("%d %d", &N, &M);

	for (i = 1; i <= N; i++) {
		scanf("%d %d", &aa, &bb);

		a[i] = bb - aa - 1;
	}

	int nr0 = 0;

	int xr = 0, q, val;

	for (i = 1; i <= N; i++) {
		nr0 += a[i] == 0;
		xr ^= a[i];
//		printf("%d\n", i);
		baga(i, 1);
	}

//	printf("xor = %d\n", xr);
//	printf("----------\n");


	while (nr0 < N) {
		for (j = 1, k = 0; j <= xr; j <<= 1, k++);
		k--;
		
		q = get_nr(k, 1, N, 1);

		xr ^= a[q];

//		if (a[q] <= xr) printf("kkkkkkkkkkkkkkkkk\n");

		printf("%d %d\n", q, a[q] - xr);
		fflush(stdout);

		baga(q, 0);

		a[q] = xr;
		xr = 0;
		baga(q, 1);

		if (a[q] == 0) nr0++;
		if (nr0 == N) break;

/*		int xx = 0;
		for (i = 1; i <= N; i++) {
			printf("%d ", a[i]);
			xx ^= a[i];
		}
		printf("| %d\n", xx);
*/
		scanf("%d %d", &q, &val);

		xr ^= a[q];
		baga(q, 0);
		a[q] -= val;
		nr0 += a[q] == 0;
		baga(q, 1);
		xr ^= a[q];
	}

return 0;
}

