#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define MAXN 3010
#define MAX_B (MAXN/32)+4
#define MOD 666013

typedef struct t_pair { int val, poz; } t_pair;

int N, M, res, *G[MAXN], deg[MAXN], R[MAXN], perm[MAXN];
unsigned int A[MAXN][MAX_B];

t_pair S[MAXN];

int VAL;
char viz[MAXN];

void baga(int i, int x)
{
    A[i][x>>5] |= ((unsigned int)1 << (x&31));
}

void dfs(int x)
{
    int *p;

    for(p = G[x]; *p; p++)
     if(!viz[*p])
        viz[*p] = 1, baga(*p, VAL), dfs(*p);
}

void solve(void)
{
    int x, i, j, k, t, b, T, nr;

    for(i = 1; i <= N; i++)
    {
        memset(viz, 0, sizeof(viz)), VAL = R[i];
        baga(i, VAL), viz[i] = 1, dfs(i);
    }

    for(res = 0, T = N/32, b = 1, i = N; i >= 1; i--)
     for(j = N; j > i; j--)
     {
        for(k = 0; k <= T; k++)
         if(A[i][k]&A[j][k])
            break ;
        if(k == T+1)
            x = 0;
        else
        {
            for(t = 0; t < 32; t++)
             if(  A[i][k]&A[j][k]&( (unsigned int)1<<t )  )
                break ;
            x = (k<<5)+t;
        }
        nr = b*perm[x]%MOD;
        res += nr;
        if(res >= MOD)
            res -= MOD;
        b = b*(N+1) % MOD;
     }
}

int edge[1<<15][2];

int cmp(const void *a, const void *b)
{
    return ((t_pair*)a)->val - ((t_pair*)b)->val;
}

void read_data(void)
{
    int a, b, i;

    scanf("%d %d\n", &N, &M);

    for(i = 1; i <= N; i++)
        scanf("%d ", &a), S[i].val = a, S[i].poz = i;

    qsort(S+1, N, sizeof(S[0]), cmp);

    for(i = 1; i <= N; i++)
        R[ S[i].poz ] = i, perm[i] = S[i].poz;

    for(i = 1; i <= M; i++)
    {
        scanf("%d %d\n", &a, &b);
        edge[i][0] = b, edge[i][1] = a, deg[b]++;
    }

    for(i = 1; i <= N; i++)
        G[i] = (int*) malloc(sizeof(int)*(deg[i]+4)),
        G[i][deg[i]] = 0, deg[i] = 0;

    for(i = 1; i <= M; i++)
    {
        a = edge[i][0], b = edge[i][1];
        G[a][deg[a]++] = b;
    }
}

void write_data(void)
{
    printf("%d\n", res);
}

int main(void)
{
    freopen("casute.in", "rt", stdin);
    freopen("casute.out", "wt", stdout);

    read_data();
    solve();
    write_data();

    return 0;
}



        




