#include <cstdio>
#include <cstring>
#include <vector>
#include <algorithm>

using namespace std;

#define vi vector<int>
#define sz size()
#define pb push_back

#define Nmax 3005
#define mod 666013

int n, m, rez;
int h[Nmax];

vi vec[Nmax], vec2[Nmax];

char viz[Nmax];
int unde[Nmax];
int list[Nmax], cont;
int place[Nmax];

int put[4500005];

void readdata()
{
   freopen("casute.in", "r", stdin);
   freopen("casute.out", "w", stdout);

   int i, a, b;

   scanf("%d %d", &n, &m);
   for (i = 1; i <= n; ++i)
       scanf("%d", &h[i]);
   for (i = 1; i <= m; ++i)
   {
      scanf("%d %d", &a, &b);
      vec[a].pb(b);
      vec2[b].pb(a);
   }
}

inline void prelucreaza(int a, int b, int c)
{
   if (a > b) a ^= b ^= a ^= b;

   int nr, aux = n-a;

   nr = aux*(aux+1)/2 - b + a;
   rez += put[nr]*c;
   if (rez >= mod) rez %= mod;

}

inline int cmp(int a, int b)
{ return h[a] < h[b]; }

void df(int k, int val, int limit)
{
   int i, nod;

   unde[k] = val;
   for (i = 0; i < vec2[k].sz; ++i)
   {
      nod = vec2[k][i];
      if (!unde[nod] && place[nod] > limit)
         df(nod, val, limit);
   }
}

void df2(int k)
{
   int i, nod;

   unde[k] = k;
   for (i = 0; i < vec[k].sz; ++i)
   {
      nod = vec[k][i];
      if (!unde[nod]) df2(nod);
   }
}

void precalculeaza()
{
   int i, lim = n*(n-1)/2, m = n+1;

   put[0] = 1;

   for (i = 1; i <= lim; ++i)
   {
      put[i] = put[i-1]*m;
      if (put[i] >= mod) put[i] %= mod;
   }
}

void solve()
{
   int i, j, nod, nod2;

   precalculeaza();

   //sorteaza in ordinea inaltimii
   for (i = 1; i <= n; ++i)
       list[i] = i;
   sort(list+1, list+n+1, cmp);
   for (i = 1; i <= n; ++i)
       place[ list[i] ] = i;

   //rezolva
   for (i = 1; i <= n; ++i)
   {
      nod = list[i];
      
      memset(unde, 0, sizeof(unde));

      df2(nod);

      for (j = i+1; j <= n; ++j)
          if (unde[ list[j] ])
             df(list[j], unde[ list[j] ], i);

      for (j = i+1; j <= n; ++j)
          if (unde[ list[j] ])
             prelucreaza(nod, list[j], unde[ list[j] ]);
   }

   printf("%d\n", rez);
}

int main()
{
   readdata();
   solve();
   return 0;
}
