#include <cstdio>
#include <cstring>

#define Nmax 152
#define inf 1000000000 // un miliard

int n, m, rez;
int a[Nmax][Nmax];

short int s[Nmax][Nmax];
short int l[Nmax][Nmax][Nmax], r[Nmax][Nmax][Nmax];

int sp[Nmax];

int Q[Nmax], cap, cont;

void readdata()
{
   freopen("imax.in", "r", stdin);
   freopen("imax.out", "w", stdout);

   int i, j;

   scanf("%d %d", &n, &m);
   for (i = 1; i <= n; ++i)
   for (j = 1; j <= m; ++j)
       scanf("%d", &a[i][j]);
}

inline int min(int a, int b) { return (a < b ? a : b); }
inline int max(int a, int b) { return (a > b ? a : b); }

void calc1()
{
   int i, j, k;
   int best;

   memset(sp, 0, sizeof(sp));
   for (i = 1; i <= n; ++i)
   {
      for (j = 1; j <= m; ++j)
          if (a[i][j]) sp[j] = 0;
          else ++sp[j];

      if (i > 1)
      {
            for (j = 2; j < m; ++j)
            for (k = m-1; k >= j; --k)
                      l[i][j][k] = max( max(l[i][j][k+1], l[i][j-1][k]), s[j-1][k+1]);
      }

      for (j = 1; j <= m; ++j)
      {
         best = inf;
         for (k = j; k <= m; ++k)
         {
            best = min(best, sp[k]);
            s[j][k] = (k-j+1) * best;
         }
      }
   }
}

void calc2()
{
   int i, j, k;
   int best;

   memset(sp, 0, sizeof(sp));
   for (i = n; i; --i)
   {
      for (j = 1; j <= m; ++j)
          if (a[i][j]) sp[j] = 0;
          else ++sp[j];

      if (i < n)
      {
         for (j = 2; j < m; ++j)
         for (k = m-1; k >= j; --k)
              r[i][j][k] = max( max(r[i][j][k+1], r[i][j-1][k]), s[j-1][k+1]);
      }

      for (j = 1; j <= m; ++j)
      {
         best = inf;
         for (k = j; k <= m; ++k)
         {
            best = min(best, sp[k]);
            s[j][k] = (k-j+1) * best;
         }
      }
   }
}

void calc5()
{
   int i, j, k;

   for (i = 1; i <= m; ++i)
   {
      memset(sp, 0, sizeof(sp));
      for (j = i; j <= m; ++j)
      {
            cap = 1; cont = 0;
            for (k = 1; k <= n; ++k)
                if (a[k][j]) sp[k] = 0;
                else ++sp[k];
                
            for (k = 1; k <= n; ++k)
                if (sp[k] < j-i+1)
                {
                    cap = 1;
                    cont = 0;
                }
                else
                {
                    if (l[k][i][j])
                    {
                        while (cont >= cap && l[k][i][j] + (k-Q[cont])*(j-i+1) >= l[ Q[cont] ][i][j])
                              --cont;
                        Q[++cont] = k;
                    }
                    if (cap <= cont && r[k][i][j])
                        rez = max(rez, (k-Q[cap]+1)*(j-i+1) + r[k][i][j] + l[ Q[cap] ][i][j]);
                }
      }
   }
}

void solve()
{
   calc1();
   calc2();
   calc5();
   printf("%d\n", rez);
}

int main()
{
   readdata();
   solve();
   return 0;
}
