#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define nmax 3005
#define MOD 666013

struct nod
{
   int x;
   nod *n;
};

int n,m,h[nmax],sol,i,j,k,ord[nmax];
short cc[nmax][nmax],lst[nmax],nl,a,b,v[nmax];
nod *adj[nmax],*aux;

int fc(const void *a,const void *b)
{
   return h[*(int*)a]-h[*(int*)b];
}

void fill(int x)
{
   nod *aux;
   v[x]=1;
   for (aux=adj[x];aux!=NULL;aux=aux->n)
      if (!v[aux->x])
         v[aux->x]=1,fill(aux->x);
}

int main()
{
   freopen("casute.in","r",stdin);
   freopen("casute.out","w",stdout);

   scanf("%d%d",&n,&m);
   for (i=0;i<n;i++)
      scanf("%d",h+i),ord[i]=i;
   qsort((void*)ord,n,sizeof(ord[0]),fc);
   for (i=0;i<m;i++)
   {
      scanf("%d%d",&a,&b);
      --a,--b;
      aux=new nod;
      aux->x=a,aux->n=adj[b],adj[b]=aux;
   }

   for (i=0;i<n;i++)
   {
      memset(v,0,sizeof(v));
      fill(ord[i]);
      nl=0;
      for (j=0;j<n;j++)
         if (v[j])
            lst[nl]=j,++nl;
      for (j=0;j<nl;j++)
         for (k=j+1;k<nl;k++)
            if (cc[lst[j]][lst[k]]==0)
               cc[lst[j]][lst[k]]=ord[i]+1;
   }
   for (i=0;i<n;i++)
      for (j=i+1;j<n;j++)
         sol=(sol*(n+1)+cc[i][j])%MOD;

   printf("%d\n",sol);

   return 0;
}

