#include <cstdio>

#define NMAX 3005
#define MOD 666013
struct NOD {int x; NOD *adr;};

int N,M,H[NMAX];
NOD *prim[NMAX];
bool vizitat1[NMAX],vizitat2[NMAX];
int baza[NMAX*(NMAX-1)/2];

inline void adaug_st(NOD *(&prim), int x)
  {
   NOD *a=new NOD;
   a->x=x;
   a->adr=prim;
   prim=a;
  }

void read_data()
  {
   int u,v;
   scanf("%d %d",&N,&M);
   for(int i=1;i<=N;i++)
      {scanf("%d",&H[i]);
       prim[i]=NULL;}
   for(int i=1;i<=M;i++)
      {
       scanf("%d %d",&u,&v);
       adaug_st(prim[u],v);
      }
  }

void init()
  {
   baza[0]=1;
   for(int i=1;i<=N*(N-1)/2;i++)
      baza[i]=((long long)baza[i-1]*(N+1))%MOD;
  }

void bf(int primul, bool (&vizitat)[NMAX])
  {
   int i,start=0,end=0,coada[NMAX];
   for(i=1;i<=N;i++)
      vizitat[i]=false;
   vizitat[primul]=true;
   coada[start]=primul;
   while(start<=end)
        {
         NOD *b=prim[coada[start]];
         while(b)
              {
               if(!vizitat[b->x])
                 {
                  vizitat[b->x]=true;
                  coada[++end]=b->x;
                 }
               b=b->adr;
              }
         start++;
        }
  }


int main()
{
freopen("casute.in","r",stdin);
freopen("casute.out","w",stdout);

long long rest=0;
read_data();
init();
int cnt=0;
for(int i=N;i>=1;i--)
   for(int j=N;j>=i+1;j--)
      {
       bf(i,vizitat1);
       bf(j,vizitat2);
       int poz=-1;
       for(int k=1;k<=N;k++)
          if(vizitat1[k] && vizitat2[k])
            if(poz==-1 || H[poz]>H[k])
              poz=k;
       if(poz==-1)
         poz=0;
       // update rest
       rest=(rest+(long long)poz*baza[cnt])%MOD;
       cnt++;
      }

printf("%Ld\n",rest);

return 0;
}
