#include <stdio.h>
#include <algorithm>
#include <vector>

using namespace std;

#define pb push_back
#define sz size()
#define nm 3005
#define mod 666013

struct casa
{
	int h, p;
};

int n, m, v[nm], len[nm], used[nm], sol;
short int rez[nm][nm];
char desc[nm][nm];
vector<int> mat[nm];
casa a[nm];

int comp(casa a, casa b)
{
	return a.h < b.h;
}

void go(int nod)
{
	int i, j;
		
	used[nod] = 1;
		
	for (i = 0; i < len[nod]; ++i)
	{
		if (!used[mat[nod][i]])
			go(mat[nod][i]);
		
		desc[nod][mat[nod][i]] = 1;
		
		for (j = 1; j <= n; ++j)
			desc[nod][j] = desc[nod][j] || desc[mat[nod][i]][j];
	}
}

int main()
{
	int i, j, k, x, y, tmp;

	freopen("casute.in", "r", stdin);
	freopen("casute.out", "w", stdout);

	scanf("%d%d", &n, &m);

	for (i = 1; i <= n; ++i)
	{
		a[i].p = i;
		scanf("%d", &a[i].h);
	}

	sort(a + 1, a + n + 1, comp);

	for (i = 1; i <= n; ++i)
		v[a[i].p] = i;

	for (i = 1; i <= m; ++i)
	{
		scanf("%d%d", &x, &y);

		mat[v[x]].pb(v[y]);
	}

	for (i = 1; i <= n; ++i)
		len[i] = mat[i].sz;

	for (i = 1; i <= n; ++i)
		if (!used[i])
			go(i);			

	for (i = 1; i <= n; ++i)
		for (j = k = 1; j <= n; ++j) if (desc[i][j])
			for (; k <= j; ++k)
				rez[i][k] = j;

	for (i = 1; i <= n; ++i)
		for (j = i + 1; j <= n; ++j)
			rez[j][i] = rez[i][j];

	for (tmp = 1, i = n; i; --i)
		for (j = n; j > i; --j, tmp = (tmp * (n + 1)) % mod)
			sol = (sol + tmp * a[rez[v[i]][v[j]]].p) % mod;

	printf("%d\n", sol);

	return 0;
}
