#include <stdio.h>
#include <string.h>
#include <algorithm>
#include <vector>

using namespace std;

#define CLEAR(x) memset(x, 0, sizeof(x))
#define pb push_back
#define ll long long
#define MOD 666013
#define NMax 3005
#define BMax 60

int N, M, H[NMax], O[NMax], poz[NMax], uz[NMax], C[NMax], R[NMax];
ll D[NMax][BMax], P[65];
vector<int> G[NMax];

int cnt = 0;

int cmp_h(const int& a, const int& b)
{ return H[a] < H[b]; }

void df(int nod)
{
    vector<int>::iterator it;

    uz[nod] = 1;
    for (it = G[nod].begin(); it != G[nod].end(); ++it)
        if (!uz[*it])
           df(*it);
}

int first_bit(int x, int y)
{
   int i;

   for (i = 0; i < 60; i++)
       if ((x & P[i]) && (y & P[i]))
          return i;
   return 0;
}

int comun(int x, int y)
{
    int i, max;

    max = x; if (y > x) max = y;
    for (i = C[max]; i <= C[N]; i++)
        if (D[x][i] & D[y][i])
           return first_bit(D[x][i], D[y][i]);
    return 0;
}

int main(void)
{
    int i, j, u, v, c, pt;
    
    freopen("casute.in", "r", stdin);
    freopen("casute.out", "w", stdout);

    scanf("%d %d", &N, &M);
    for (i = 1; i <= N; i++)
        scanf("%d", &H[i]);
    for (i = 1; i <= N; i++) O[i] = i;

    sort(O+1, O+N+1, cmp_h);
    for (i = 1; i <= N; i++) poz[O[i]] = i;
    for (i = 1; i <= N; i++) H[i] = poz[i];
    
    for (i = 1; i <= N; i++) poz[H[i]] = i;
        
    for (; M; M--)
    {
         scanf("%d %d", &u, &v);
         G[u].pb(v);
    }

    for (i = 1; i <= N; i++) C[i] = i/BMax, R[i] = i%BMax;
    for (i = 0; i < BMax; i++) P[i] = ((ll)1<<i);

    for (i = 1; i <= N; i++)
    {
        CLEAR(uz);
        df(i);
        for (j = 1; j <= N; j++)
            if (uz[j])
            {
                pt = H[j];
                D[i][ C[pt] ] += P[ R[pt] ];
            }
    }

    for (i = 1; i <= N; i++)
        for (j = i+1; j <= N; j++)
        {
            c = comun(i, j);
            c = poz[c];
            
            cnt = (cnt * (N+1) + c) % MOD;
        }

    printf("%d\n", cnt);

    return 0;
}

