#include <stdio.h>
#include <string.h>


#define NMAX 410
#define CMAX 20
#define BASE 100000000
#define FORMAT "%08d"

int N, S;

int ant[NMAX][CMAX];
int cur[NMAX][CMAX];

void add(int a[], int b[])
{
	int i, t = 0;

	for (i = 1; i <= a[0] || i <= b[0] || t; i++, t /= BASE)
		a[i] = (t += a[i] + b[i]) % BASE;

	a[0] = i - 1;
}

void print_nr(int a[])
{
	int i;

	printf("%d", a[a[0]]);
	for (i = a[0] - 1; i >= 1; i--)
		printf(FORMAT, a[i]);
	printf("\n");
}

int main()
{
	int i, j;
	
	freopen("naveta.in", "r", stdin);
	freopen("naveta.out", "w", stdout);

	scanf("%d %d", &S, &N);

	for (i = 1; i <= N; i++) {
		ant[i][0] = 1;
		ant[i][1] = i;
	}

	int q;
	for (i = 2; i <= N; i++) {
		q = (i - 1) * S;
		for (j = 1; j <= i * S; j++) {
			if (j <= q) memcpy(cur[j], ant[j - 1], sizeof(cur[j]));
			else memcpy(cur[j], ant[q], sizeof(cur[j]));

			add(cur[j], cur[j-1]);
		}

		memcpy(ant, cur, sizeof(ant));
	}

	print_nr(cur[N * S]);


fclose(stdin);
fclose(stdout);
return 0;
}

