#include <cstdio>
#include <cstring>

#define Nmax 64
#define Lmax 8
#define base 1000000000
#define min(a,b) ((a) < (b) ? (a) : (b))

int n, k;
int d1[Nmax][Nmax][2][Lmax], d2[Nmax][Nmax][2][Lmax];

void citire()
{
	scanf("%d %d\n", &n, &k);
}

inline void add(int A[], int B[])
{
    int i, t = 0;

    for (i = 1; i <= A[0] || i <= B[0] || t; ++i, t /= base)
    	A[i] = (t += A[i] + B[i]) % base;

    if (i - 1 > A[0])
    	A[0] = i - 1;
}

void solve()
{
	int i, j, l;

    d1[0][0][0][0] = d1[0][0][0][1] = 1;

    for (l = 1; l <= 2 * n; ++l)
    {
    	memcpy(d2, d1, sizeof(d1));
        memset(d1, 0, sizeof(d1));
        for (i = 0; i <= min(n, l); ++i)
            for (j = 0; j <= k; ++j)
            {
                if (i > 0)
                {
                	add(d1[i][j][0], d2[i - 1][j][0]);
                    add(d1[i][j][0], d2[i - 1][j][1]);
                }
                if (j > 0)
                	add(d1[i][j][1], d2[i + 1][j - 1][0]);
                add(d1[i][j][1], d2[i + 1][j][1]);
            }
    }

    printf("%d", d1[0][k][1][ d1[0][k][1][0] ]);
    for (i = d1[0][k][1][0] - 1; i > 0; --i)
    	printf("%.9d", d1[0][k][1][i]);
    printf("\n");
}

int main()
{
	freopen("culmi.in", "r", stdin);
    freopen("culmi.out", "w", stdout);
    citire();
    solve();
    return 0;
}
