#include <stdio.h>
#include <algorithm>

using namespace std;

#define MAX_N 155
#define FIN "imax.in"
#define FOUT "imax.out"

int N, M, Res, A[MAX_N][MAX_N], L[MAX_N][MAX_N], R[MAX_N][MAX_N];

int main(void)
{
    int i, j, ic1, ic2, ir, br, tr, best, l, r; 

    freopen(FIN, "r", stdin);
    freopen(FOUT, "w", stdout);

    scanf("%d %d", &N, &M);
    fill(A[0], A[0]+M+2, 1);
    fill(A[N+1], A[N+1]+M+2, 1);
    for (i = 1; i <= N; i++)
    {
        A[i][0] = A[i][M+1] = 1;
        for (j = 1; j <= M; j++)
            scanf("%d", A[i]+j);
    }

    for (i = 1; i <= N; i++)
    {
        L[i][0] = 0;
        for (j = 1; j <= M; j++)
            L[i][j] = A[i][j] ? j : L[i][j-1];
        R[i][M+1] = M+1;
        for (j = M; j >= 1; j--)
            R[i][j] = A[i][j] ? j : R[i][j+1];
    }

    for (ic1 = 1; ic1 <= M; ic1++)
    {
        int T[MAX_N] = {0};
        for (ir = N; ir >= 1; ir--)
        {
            for (i = R[ir][ic1]; i <= M; i++) T[i] = 0;
            if (A[ir][ic1]) continue;
            ic2 = R[ir][ic1]-1; best = 0;
            l = 1; r = M;
            for (br = ir+1; br <= N; br++)
            {
                l = max(l, L[br][ic1]+1);
                r = min(r, R[br][ic1]-1);
                if (l >= ic1 || r <= ic1) break;
                if (r <= ic2)
                {
                    if (best)
                        for (i = r; i <= ic2; i++)
                            T[i] = max(T[i], best+ir*(i-ic1+1));
                    ic2 = r-1;
                }
                best = max(best, (br-ir)*(r-l+1));
            }
            if (best)
                for (i = ic1; i <= ic2; i++)
                    T[i] = max(T[i], best+ir*(i-ic1+1));

            ic2 = R[ir][ic1]-1; best = 0;
            l = 1; r = M;
            for (tr = ir-1; tr >= 1; tr--)
            {
                l = max(l, L[tr][ic1]+1);
                r = min(r, R[tr][ic1]-1);
                if (l >= ic1 || r <= ic1) break;
                if (r <= ic2)
                {
                    if (best)
                    for (i = r; i <= ic2; i++)
                        if (T[i]) Res = max(Res, best+T[i]-(ir-1)*(i-ic1+1));
                    ic2 = r-1;
                }
                best = max(best, (ir-tr)*(r-l+1));
            }
            if (best)
                for (i = ic1; i <= ic2; i++)
                    if (T[i]) Res = max(Res, best+T[i]-(ir-1)*(i-ic1+1));
        }
    }

    printf("%d\n", Res);

    return 0;
}
