#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <vector>
#include <list>
using namespace std;

#define NMAX 1000005
#define MP   make_pair
#define PB   push_back
#define HMAX 666013
#define ABS(x) ((x) >= 0 ? (x) : -(x))

pair<int, int> a[NMAX];
int N, i, j, k, delta, x, gl;
list<int> h[HMAX];

const int dx[4] = {-1, -1, 0, 1};
const int dy[4] = { 0,  1, 1, 1};

inline int hf(int x, int y)
{
    int r = (x*9901+y+HMAX)%HMAX;
    return r;
}

int add(int x)
{
    int cx = a[x].first/gl, cy = a[x].second/gl;
    int p = hf(cx, cy);
    for (list<int> :: iterator it = h[p].begin(); it != h[p].end(); it ++)
        if (a[*it].first/gl == cx && a[*it].second/gl == cy)
            return 0;
    h[p].PB(x);
    return 1;
}

int fnd(int cx, int cy, int x, int y)
{
    int p = hf(x, y);
    for (list<int> :: iterator it = h[p].begin(); it != h[p].end(); it ++)
        if ( (a[*it].first != cx || a[*it].second != cy) &&

        ABS(a[*it].first - cx) <= gl && ABS(a[*it].second - cy) <= gl)
            return 1;
    return 0;
}

int baga(int l)
{
    int cx, cy, i;
    for (i = 0; i < HMAX; i ++) h[i].clear();

    gl = l;
    for (i = 0; i < N; i ++)
        if (!add(i))
            return 0;

    for (i = 0; i < N; i ++)
    {
        cx = a[i].first/gl, cy = a[i].second/gl;
        for (j = 0; j < 4; j ++)
            if (fnd(a[i].first, a[i].second, cx+dx[j], cy+dy[j]))
                return 0;
    }

    return 1;
}

int main(void)
{
    freopen("harta.in", "r", stdin);
    freopen("harta.out", "w", stdout);
    scanf("%d", &N);
    for (i = 0; i < N; i ++)
        scanf("%d %d", &j, &k), a[i] = MP(j, 3*k);

    for (delta = 1<<19, x = 0; delta; delta >>= 1)
        if (baga(x+delta))
            x += delta;

    printf("%0.3lf\n", (double)(x+1)/3);
    return 0;
}
